gi-harfbuzz-0.0.3: HarfBuzz bindings

Copyright | Will Thompson Iñaki García Etxebarria and Jonas Platte
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.HarfBuzz.Functions

Contents

- Methods
  - blobCopyWritableOrFail
  - blobCreateFromFile
  - blobCreateSubBlob
  - blobGetData
  - blobGetDataWritable
  - blobGetEmpty
  - blobGetLength
  - blobIsImmutable
  - blobMakeImmutable
  - bufferAdd
  - bufferAddCodepoints
  - bufferAddLatin1
  - bufferAddUtf16
  - bufferAddUtf32
  - bufferAddUtf8
  - bufferAllocationSuccessful
  - bufferAppend
  - bufferClearContents
  - bufferCreate
  - bufferDeserializeGlyphs
  - bufferDiff
  - bufferGetClusterLevel
  - bufferGetContentType
  - bufferGetDirection
  - bufferGetEmpty
  - bufferGetFlags
  - bufferGetGlyphInfos
  - bufferGetGlyphPositions
  - bufferGetInvisibleGlyph
  - bufferGetLanguage
  - bufferGetLength
  - bufferGetReplacementCodepoint
  - bufferGetScript
  - bufferGetSegmentProperties
  - bufferGetUnicodeFuncs
  - bufferGuessSegmentProperties
  - bufferNormalizeGlyphs
  - bufferPreAllocate
  - bufferReset
  - bufferReverse
  - bufferReverseClusters
  - bufferReverseRange
  - bufferSerializeFormatFromString
  - bufferSerializeFormatToString
  - bufferSerializeGlyphs
  - bufferSerializeListFormats
  - bufferSetClusterLevel
  - bufferSetContentType
  - bufferSetDirection
  - bufferSetFlags
  - bufferSetInvisibleGlyph
  - bufferSetLanguage
  - bufferSetLength
  - bufferSetMessageFunc
  - bufferSetReplacementCodepoint
  - bufferSetScript
  - bufferSetSegmentProperties
  - bufferSetUnicodeFuncs
  - colorGetAlpha
  - colorGetBlue
  - colorGetGreen
  - colorGetRed
  - directionFromString
  - directionToString
  - faceBuilderAddTable
  - faceBuilderCreate
  - faceCollectUnicodes
  - faceCollectVariationSelectors
  - faceCollectVariationUnicodes
  - faceCount
  - faceCreate
  - faceCreateForTables
  - faceGetEmpty
  - faceGetGlyphCount
  - faceGetIndex
  - faceGetTableTags
  - faceGetUpem
  - faceIsImmutable
  - faceMakeImmutable
  - faceReferenceBlob
  - faceReferenceTable
  - faceSetGlyphCount
  - faceSetIndex
  - faceSetUpem
  - featureFromString
  - featureToString
  - fontAddGlyphOriginForDirection
  - fontCreate
  - fontCreateSubFont
  - fontFuncsCreate
  - fontFuncsGetEmpty
  - fontFuncsIsImmutable
  - fontFuncsMakeImmutable
  - fontFuncsSetFontHExtentsFunc
  - fontFuncsSetFontVExtentsFunc
  - fontFuncsSetGlyphContourPointFunc
  - fontFuncsSetGlyphExtentsFunc
  - fontFuncsSetGlyphFromNameFunc
  - fontFuncsSetGlyphFunc
  - fontFuncsSetGlyphHAdvanceFunc
  - fontFuncsSetGlyphHAdvancesFunc
  - fontFuncsSetGlyphHKerningFunc
  - fontFuncsSetGlyphHOriginFunc
  - fontFuncsSetGlyphNameFunc
  - fontFuncsSetGlyphVAdvanceFunc
  - fontFuncsSetGlyphVAdvancesFunc
  - fontFuncsSetGlyphVKerningFunc
  - fontFuncsSetGlyphVOriginFunc
  - fontFuncsSetNominalGlyphFunc
  - fontFuncsSetNominalGlyphsFunc
  - fontFuncsSetVariationGlyphFunc
  - fontGetEmpty
  - fontGetExtentsForDirection
  - fontGetFace
  - fontGetGlyph
  - fontGetGlyphAdvanceForDirection
  - fontGetGlyphAdvancesForDirection
  - fontGetGlyphContourPoint
  - fontGetGlyphContourPointForOrigin
  - fontGetGlyphExtents
  - fontGetGlyphExtentsForOrigin
  - fontGetGlyphFromName
  - fontGetGlyphHAdvance
  - fontGetGlyphHAdvances
  - fontGetGlyphHKerning
  - fontGetGlyphHOrigin
  - fontGetGlyphKerningForDirection
  - fontGetGlyphName
  - fontGetGlyphOriginForDirection
  - fontGetGlyphVAdvance
  - fontGetGlyphVAdvances
  - fontGetGlyphVKerning
  - fontGetGlyphVOrigin
  - fontGetHExtents
  - fontGetNominalGlyph
  - fontGetNominalGlyphs
  - fontGetParent
  - fontGetPpem
  - fontGetPtem
  - fontGetScale
  - fontGetVExtents
  - fontGetVarCoordsNormalized
  - fontGetVariationGlyph
  - fontGlyphFromString
  - fontGlyphToString
  - fontIsImmutable
  - fontMakeImmutable
  - fontSetFace
  - fontSetFuncs
  - fontSetFuncsData
  - fontSetParent
  - fontSetPpem
  - fontSetPtem
  - fontSetScale
  - fontSetVarCoordsDesign
  - fontSetVarCoordsNormalized
  - fontSetVarNamedInstance
  - fontSetVariations
  - fontSubtractGlyphOriginForDirection
  - ftFontChanged
  - ftFontGetLoadFlags
  - ftFontSetFuncs
  - ftFontSetLoadFlags
  - ftFontUnlockFace
  - glibBlobCreate
  - glibGetUnicodeFuncs
  - glibScriptFromScript
  - glibScriptToScript
  - glyphInfoGetGlyphFlags
  - languageFromString
  - languageGetDefault
  - languageToString
  - mapAllocationSuccessful
  - mapClear
  - mapCreate
  - mapDel
  - mapGet
  - mapGetEmpty
  - mapGetPopulation
  - mapHas
  - mapIsEmpty
  - mapSet
  - otColorGlyphGetLayers
  - otColorGlyphReferencePng
  - otColorGlyphReferenceSvg
  - otColorHasLayers
  - otColorHasPalettes
  - otColorHasPng
  - otColorHasSvg
  - otColorPaletteColorGetNameId
  - otColorPaletteGetColors
  - otColorPaletteGetCount
  - otColorPaletteGetFlags
  - otColorPaletteGetNameId
  - otFontSetFuncs
  - otLayoutFeatureGetCharacters
  - otLayoutFeatureGetLookups
  - otLayoutFeatureGetNameIds
  - otLayoutFeatureWithVariationsGetLookups
  - otLayoutGetAttachPoints
  - otLayoutGetBaseline
  - otLayoutGetGlyphClass
  - otLayoutGetLigatureCarets
  - otLayoutGetSizeParams
  - otLayoutHasGlyphClasses
  - otLayoutHasPositioning
  - otLayoutHasSubstitution
  - otLayoutLanguageFindFeature
  - otLayoutLanguageGetFeatureIndexes
  - otLayoutLanguageGetFeatureTags
  - otLayoutLanguageGetRequiredFeature
  - otLayoutLanguageGetRequiredFeatureIndex
  - otLayoutLookupWouldSubstitute
  - otLayoutScriptFindLanguage
  - otLayoutScriptGetLanguageTags
  - otLayoutScriptSelectLanguage
  - otLayoutTableChooseScript
  - otLayoutTableFindFeatureVariations
  - otLayoutTableFindScript
  - otLayoutTableGetFeatureTags
  - otLayoutTableGetLookupCount
  - otLayoutTableGetScriptTags
  - otLayoutTableSelectScript
  - otMathGetConstant
  - otMathGetGlyphAssembly
  - otMathGetGlyphItalicsCorrection
  - otMathGetGlyphKerning
  - otMathGetGlyphTopAccentAttachment
  - otMathGetGlyphVariants
  - otMathGetMinConnectorOverlap
  - otMathHasData
  - otMathIsGlyphExtendedShape
  - otMetaGetEntryTags
  - otMetaReferenceEntry
  - otMetricsGetPosition
  - otMetricsGetVariation
  - otMetricsGetXVariation
  - otMetricsGetYVariation
  - otNameGetUtf16
  - otNameGetUtf32
  - otNameGetUtf8
  - otNameListNames
  - otShapeGlyphsClosure
  - otTagFromLanguage
  - otTagToLanguage
  - otTagToScript
  - otTagsFromScript
  - otTagsFromScriptAndLanguage
  - otTagsToScriptAndLanguage
  - otVarFindAxis
  - otVarFindAxisInfo
  - otVarGetAxes
  - otVarGetAxisCount
  - otVarGetAxisInfos
  - otVarGetNamedInstanceCount
  - otVarHasData
  - otVarNamedInstanceGetDesignCoords
  - otVarNamedInstanceGetPostscriptNameId
  - otVarNamedInstanceGetSubfamilyNameId
  - otVarNormalizeCoords
  - otVarNormalizeVariations
  - scriptFromIso15924Tag
  - scriptFromString
  - scriptGetHorizontalDirection
  - scriptToIso15924Tag
  - segmentPropertiesEqual
  - segmentPropertiesHash
  - setAdd
  - setAddRange
  - setAllocationSuccessful
  - setClear
  - setCreate
  - setDel
  - setDelRange
  - setGetEmpty
  - setGetMax
  - setGetMin
  - setGetPopulation
  - setHas
  - setIntersect
  - setInvert
  - setIsEmpty
  - setIsEqual
  - setIsSubset
  - setNext
  - setNextRange
  - setPrevious
  - setPreviousRange
  - setSet
  - setSubtract
  - setSymmetricDifference
  - setUnion
  - shape
  - shapeFull
  - shapeListShapers
  - shapePlanCreate
  - shapePlanCreate2
  - shapePlanCreateCached
  - shapePlanCreateCached2
  - shapePlanExecute
  - shapePlanGetEmpty
  - shapePlanGetShaper
  - tagFromString
  - unicodeCombiningClass
  - unicodeCompose
  - unicodeDecompose
  - unicodeDecomposeCompatibility
  - unicodeEastasianWidth
  - unicodeFuncsCreate
  - unicodeFuncsGetDefault
  - unicodeFuncsGetEmpty
  - unicodeFuncsGetParent
  - unicodeFuncsIsImmutable
  - unicodeFuncsMakeImmutable
  - unicodeFuncsSetCombiningClassFunc
  - unicodeFuncsSetComposeFunc
  - unicodeFuncsSetDecomposeCompatibilityFunc
  - unicodeFuncsSetDecomposeFunc
  - unicodeFuncsSetEastasianWidthFunc
  - unicodeFuncsSetGeneralCategoryFunc
  - unicodeFuncsSetMirroringFunc
  - unicodeFuncsSetScriptFunc
  - unicodeGeneralCategory
  - unicodeMirroring
  - unicodeScript
  - variationFromString
  - variationToString
  - version
  - versionAtleast
  - versionString

Description

Synopsis

- blobCopyWritableOrFail :: (HasCallStack, MonadIO m) => BlobT -> m BlobT
- blobCreateFromFile :: (HasCallStack, MonadIO m) => Text -> m BlobT
- blobCreateSubBlob :: (HasCallStack, MonadIO m) => BlobT -> Word32 -> Word32 -> m BlobT
- blobGetData :: (HasCallStack, MonadIO m) => BlobT -> m [Text]
- blobGetDataWritable :: (HasCallStack, MonadIO m) => BlobT -> m [Text]
- blobGetEmpty :: (HasCallStack, MonadIO m) => m BlobT
- blobGetLength :: (HasCallStack, MonadIO m) => BlobT -> m Word32
- blobIsImmutable :: (HasCallStack, MonadIO m) => BlobT -> m Int32
- blobMakeImmutable :: (HasCallStack, MonadIO m) => BlobT -> m ()
- bufferAdd :: (HasCallStack, MonadIO m) => BufferT -> Word32 -> Word32 -> m ()
- bufferAddCodepoints :: (HasCallStack, MonadIO m) => BufferT -> [Word32] -> Word32 -> Int32 -> m ()
- bufferAddLatin1 :: (HasCallStack, MonadIO m) => BufferT -> ByteString -> Word32 -> Int32 -> m ()
- bufferAddUtf16 :: (HasCallStack, MonadIO m) => BufferT -> [Word16] -> Word32 -> Int32 -> m ()
- bufferAddUtf32 :: (HasCallStack, MonadIO m) => BufferT -> [Word32] -> Word32 -> Int32 -> m ()
- bufferAddUtf8 :: (HasCallStack, MonadIO m) => BufferT -> ByteString -> Word32 -> Int32 -> m ()
- bufferAllocationSuccessful :: (HasCallStack, MonadIO m) => BufferT -> m Int32
- bufferAppend :: (HasCallStack, MonadIO m) => BufferT -> BufferT -> Word32 -> Word32 -> m ()
- bufferClearContents :: (HasCallStack, MonadIO m) => BufferT -> m ()
- bufferCreate :: (HasCallStack, MonadIO m) => m BufferT
- bufferDeserializeGlyphs :: (HasCallStack, MonadIO m) => BufferT -> [Text] -> FontT -> BufferSerializeFormatT -> m (Int32, Text)
- bufferDiff :: (HasCallStack, MonadIO m) => BufferT -> BufferT -> Word32 -> Word32 -> m [BufferDiffFlagsT]
- bufferGetClusterLevel :: (HasCallStack, MonadIO m) => BufferT -> m BufferClusterLevelT
- bufferGetContentType :: (HasCallStack, MonadIO m) => BufferT -> m BufferContentTypeT
- bufferGetDirection :: (HasCallStack, MonadIO m) => BufferT -> m DirectionT
- bufferGetEmpty :: (HasCallStack, MonadIO m) => m BufferT
- bufferGetFlags :: (HasCallStack, MonadIO m) => BufferT -> m [BufferFlagsT]
- bufferGetGlyphInfos :: (HasCallStack, MonadIO m) => BufferT -> m [GlyphInfoT]
- bufferGetGlyphPositions :: (HasCallStack, MonadIO m) => BufferT -> m [GlyphPositionT]
- bufferGetInvisibleGlyph :: (HasCallStack, MonadIO m) => BufferT -> m Word32
- bufferGetLanguage :: (HasCallStack, MonadIO m) => BufferT -> m LanguageT
- bufferGetLength :: (HasCallStack, MonadIO m) => BufferT -> m Word32
- bufferGetReplacementCodepoint :: (HasCallStack, MonadIO m) => BufferT -> m Word32
- bufferGetScript :: (HasCallStack, MonadIO m) => BufferT -> m ScriptT
- bufferGetSegmentProperties :: (HasCallStack, MonadIO m) => BufferT -> m SegmentPropertiesT
- bufferGetUnicodeFuncs :: (HasCallStack, MonadIO m) => BufferT -> m UnicodeFuncsT
- bufferGuessSegmentProperties :: (HasCallStack, MonadIO m) => BufferT -> m ()
- bufferNormalizeGlyphs :: (HasCallStack, MonadIO m) => BufferT -> m ()
- bufferPreAllocate :: (HasCallStack, MonadIO m) => BufferT -> Word32 -> m Int32
- bufferReset :: (HasCallStack, MonadIO m) => BufferT -> m ()
- bufferReverse :: (HasCallStack, MonadIO m) => BufferT -> m ()
- bufferReverseClusters :: (HasCallStack, MonadIO m) => BufferT -> m ()
- bufferReverseRange :: (HasCallStack, MonadIO m) => BufferT -> Word32 -> Word32 -> m ()
- bufferSerializeFormatFromString :: (HasCallStack, MonadIO m) => ByteString -> m BufferSerializeFormatT
- bufferSerializeFormatToString :: (HasCallStack, MonadIO m) => BufferSerializeFormatT -> m Text
- bufferSerializeGlyphs :: (HasCallStack, MonadIO m) => BufferT -> Word32 -> Word32 -> Maybe FontT -> BufferSerializeFormatT -> [BufferSerializeFlagsT] -> m (Word32, ByteString, Word32)
- bufferSerializeListFormats :: (HasCallStack, MonadIO m) => m [Text]
- bufferSetClusterLevel :: (HasCallStack, MonadIO m) => BufferT -> BufferClusterLevelT -> m ()
- bufferSetContentType :: (HasCallStack, MonadIO m) => BufferT -> BufferContentTypeT -> m ()
- bufferSetDirection :: (HasCallStack, MonadIO m) => BufferT -> DirectionT -> m ()
- bufferSetFlags :: (HasCallStack, MonadIO m) => BufferT -> [BufferFlagsT] -> m ()
- bufferSetInvisibleGlyph :: (HasCallStack, MonadIO m) => BufferT -> Word32 -> m ()
- bufferSetLanguage :: (HasCallStack, MonadIO m) => BufferT -> LanguageT -> m ()
- bufferSetLength :: (HasCallStack, MonadIO m) => BufferT -> Word32 -> m Int32
- bufferSetMessageFunc :: (HasCallStack, MonadIO m) => BufferT -> BufferMessageFuncT -> m ()
- bufferSetReplacementCodepoint :: (HasCallStack, MonadIO m) => BufferT -> Word32 -> m ()
- bufferSetScript :: (HasCallStack, MonadIO m) => BufferT -> ScriptT -> m ()
- bufferSetSegmentProperties :: (HasCallStack, MonadIO m) => BufferT -> SegmentPropertiesT -> m ()
- bufferSetUnicodeFuncs :: (HasCallStack, MonadIO m) => BufferT -> UnicodeFuncsT -> m ()
- colorGetAlpha :: (HasCallStack, MonadIO m) => Word32 -> m Word8
- colorGetBlue :: (HasCallStack, MonadIO m) => Word32 -> m Word8
- colorGetGreen :: (HasCallStack, MonadIO m) => Word32 -> m Word8
- colorGetRed :: (HasCallStack, MonadIO m) => Word32 -> m Word8
- directionFromString :: (HasCallStack, MonadIO m) => ByteString -> m DirectionT
- directionToString :: (HasCallStack, MonadIO m) => DirectionT -> m Text
- faceBuilderAddTable :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> BlobT -> m Int32
- faceBuilderCreate :: (HasCallStack, MonadIO m) => m FaceT
- faceCollectUnicodes :: (HasCallStack, MonadIO m) => FaceT -> SetT -> m ()
- faceCollectVariationSelectors :: (HasCallStack, MonadIO m) => FaceT -> SetT -> m ()
- faceCollectVariationUnicodes :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> SetT -> m ()
- faceCount :: (HasCallStack, MonadIO m) => BlobT -> m Word32
- faceCreate :: (HasCallStack, MonadIO m) => BlobT -> Word32 -> m FaceT
- faceCreateForTables :: (HasCallStack, MonadIO m) => ReferenceTableFuncT -> m FaceT
- faceGetEmpty :: (HasCallStack, MonadIO m) => m FaceT
- faceGetGlyphCount :: (HasCallStack, MonadIO m) => FaceT -> m Word32
- faceGetIndex :: (HasCallStack, MonadIO m) => FaceT -> m Word32
- faceGetTableTags :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> Word32 -> m Word32
- faceGetUpem :: (HasCallStack, MonadIO m) => FaceT -> m Word32
- faceIsImmutable :: (HasCallStack, MonadIO m) => FaceT -> m Int32
- faceMakeImmutable :: (HasCallStack, MonadIO m) => FaceT -> m ()
- faceReferenceBlob :: (HasCallStack, MonadIO m) => FaceT -> m BlobT
- faceReferenceTable :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> m BlobT
- faceSetGlyphCount :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> m ()
- faceSetIndex :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> m ()
- faceSetUpem :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> m ()
- featureFromString :: (HasCallStack, MonadIO m) => ByteString -> m (Int32, FeatureT)
- featureToString :: (HasCallStack, MonadIO m) => FeatureT -> m [Text]
- fontAddGlyphOriginForDirection :: (HasCallStack, MonadIO m) => FontT -> Word32 -> DirectionT -> m (Int32, Int32)
- fontCreate :: (HasCallStack, MonadIO m) => FaceT -> m FontT
- fontCreateSubFont :: (HasCallStack, MonadIO m) => FontT -> m FontT
- fontFuncsCreate :: (HasCallStack, MonadIO m) => m FontFuncsT
- fontFuncsGetEmpty :: (HasCallStack, MonadIO m) => m FontFuncsT
- fontFuncsIsImmutable :: (HasCallStack, MonadIO m) => FontFuncsT -> m Int32
- fontFuncsMakeImmutable :: (HasCallStack, MonadIO m) => FontFuncsT -> m ()
- fontFuncsSetFontHExtentsFunc :: (HasCallStack, MonadIO m) => FontFuncsT -> FontGetFontExtentsFuncT -> m ()
- fontFuncsSetFontVExtentsFunc :: (HasCallStack, MonadIO m) => FontFuncsT -> FontGetFontExtentsFuncT -> m ()
- fontFuncsSetGlyphContourPointFunc :: (HasCallStack, MonadIO m) => FontFuncsT -> FontGetGlyphContourPointFuncT -> m ()
- fontFuncsSetGlyphExtentsFunc :: (HasCallStack, MonadIO m) => FontFuncsT -> FontGetGlyphExtentsFuncT -> m ()
- fontFuncsSetGlyphFromNameFunc :: (HasCallStack, MonadIO m) => FontFuncsT -> FontGetGlyphFromNameFuncT -> m ()
- fontFuncsSetGlyphFunc :: (HasCallStack, MonadIO m) => FontFuncsT -> FontGetGlyphFuncT -> m ()
- fontFuncsSetGlyphHAdvanceFunc :: (HasCallStack, MonadIO m) => FontFuncsT -> FontGetGlyphAdvanceFuncT -> m ()
- fontFuncsSetGlyphHAdvancesFunc :: (HasCallStack, MonadIO m) => FontFuncsT -> FontGetGlyphAdvancesFuncT -> m ()
- fontFuncsSetGlyphHKerningFunc :: (HasCallStack, MonadIO m) => FontFuncsT -> FontGetGlyphKerningFuncT -> m ()
- fontFuncsSetGlyphHOriginFunc :: (HasCallStack, MonadIO m) => FontFuncsT -> FontGetGlyphOriginFuncT -> m ()
- fontFuncsSetGlyphNameFunc :: (HasCallStack, MonadIO m) => FontFuncsT -> FontGetGlyphNameFuncT -> m ()
- fontFuncsSetGlyphVAdvanceFunc :: (HasCallStack, MonadIO m) => FontFuncsT -> FontGetGlyphAdvanceFuncT -> m ()
- fontFuncsSetGlyphVAdvancesFunc :: (HasCallStack, MonadIO m) => FontFuncsT -> FontGetGlyphAdvancesFuncT -> m ()
- fontFuncsSetGlyphVKerningFunc :: (HasCallStack, MonadIO m) => FontFuncsT -> FontGetGlyphKerningFuncT -> m ()
- fontFuncsSetGlyphVOriginFunc :: (HasCallStack, MonadIO m) => FontFuncsT -> FontGetGlyphOriginFuncT -> m ()
- fontFuncsSetNominalGlyphFunc :: (HasCallStack, MonadIO m) => FontFuncsT -> FontGetNominalGlyphFuncT -> m ()
- fontFuncsSetNominalGlyphsFunc :: (HasCallStack, MonadIO m) => FontFuncsT -> FontGetNominalGlyphsFuncT -> m ()
- fontFuncsSetVariationGlyphFunc :: (HasCallStack, MonadIO m) => FontFuncsT -> FontGetVariationGlyphFuncT -> m ()
- fontGetEmpty :: (HasCallStack, MonadIO m) => m FontT
- fontGetExtentsForDirection :: (HasCallStack, MonadIO m) => FontT -> DirectionT -> m FontExtentsT
- fontGetFace :: (HasCallStack, MonadIO m) => FontT -> m FaceT
- fontGetGlyph :: (HasCallStack, MonadIO m) => FontT -> Word32 -> Word32 -> m (Int32, Word32)
- fontGetGlyphAdvanceForDirection :: (HasCallStack, MonadIO m) => FontT -> Word32 -> DirectionT -> m (Int32, Int32)
- fontGetGlyphAdvancesForDirection :: (HasCallStack, MonadIO m) => FontT -> DirectionT -> Word32 -> Word32 -> Word32 -> Int32 -> Word32 -> m ()
- fontGetGlyphContourPoint :: (HasCallStack, MonadIO m) => FontT -> Word32 -> Word32 -> m (Int32, Int32, Int32)
- fontGetGlyphContourPointForOrigin :: (HasCallStack, MonadIO m) => FontT -> Word32 -> Word32 -> DirectionT -> m (Int32, Int32, Int32)
- fontGetGlyphExtents :: (HasCallStack, MonadIO m) => FontT -> Word32 -> m (Int32, GlyphExtentsT)
- fontGetGlyphExtentsForOrigin :: (HasCallStack, MonadIO m) => FontT -> Word32 -> DirectionT -> m (Int32, GlyphExtentsT)
- fontGetGlyphFromName :: (HasCallStack, MonadIO m) => FontT -> [Text] -> m (Int32, Word32)
- fontGetGlyphHAdvance :: (HasCallStack, MonadIO m) => FontT -> Word32 -> m Int32
- fontGetGlyphHAdvances :: (HasCallStack, MonadIO m) => FontT -> Word32 -> Word32 -> Word32 -> Int32 -> Word32 -> m ()
- fontGetGlyphHKerning :: (HasCallStack, MonadIO m) => FontT -> Word32 -> Word32 -> m Int32
- fontGetGlyphHOrigin :: (HasCallStack, MonadIO m) => FontT -> Word32 -> m (Int32, Int32, Int32)
- fontGetGlyphKerningForDirection :: (HasCallStack, MonadIO m) => FontT -> Word32 -> Word32 -> DirectionT -> m (Int32, Int32)
- fontGetGlyphName :: (HasCallStack, MonadIO m) => FontT -> Word32 -> [Text] -> m Int32
- fontGetGlyphOriginForDirection :: (HasCallStack, MonadIO m) => FontT -> Word32 -> DirectionT -> m (Int32, Int32)
- fontGetGlyphVAdvance :: (HasCallStack, MonadIO m) => FontT -> Word32 -> m Int32
- fontGetGlyphVAdvances :: (HasCallStack, MonadIO m) => FontT -> Word32 -> Word32 -> Word32 -> Int32 -> Word32 -> m ()
- fontGetGlyphVKerning :: (HasCallStack, MonadIO m) => FontT -> Word32 -> Word32 -> m Int32
- fontGetGlyphVOrigin :: (HasCallStack, MonadIO m) => FontT -> Word32 -> m (Int32, Int32, Int32)
- fontGetHExtents :: (HasCallStack, MonadIO m) => FontT -> m (Int32, FontExtentsT)
- fontGetNominalGlyph :: (HasCallStack, MonadIO m) => FontT -> Word32 -> m (Int32, Word32)
- fontGetNominalGlyphs :: (HasCallStack, MonadIO m) => FontT -> Word32 -> Word32 -> Word32 -> Word32 -> Word32 -> m Word32
- fontGetParent :: (HasCallStack, MonadIO m) => FontT -> m FontT
- fontGetPpem :: (HasCallStack, MonadIO m) => FontT -> m (Word32, Word32)
- fontGetPtem :: (HasCallStack, MonadIO m) => FontT -> m Float
- fontGetScale :: (HasCallStack, MonadIO m) => FontT -> m (Int32, Int32)
- fontGetVExtents :: (HasCallStack, MonadIO m) => FontT -> m (Int32, FontExtentsT)
- fontGetVarCoordsNormalized :: (HasCallStack, MonadIO m) => FontT -> Word32 -> m Int32
- fontGetVariationGlyph :: (HasCallStack, MonadIO m) => FontT -> Word32 -> Word32 -> m (Int32, Word32)
- fontGlyphFromString :: (HasCallStack, MonadIO m) => FontT -> ByteString -> m (Int32, Word32)
- fontGlyphToString :: (HasCallStack, MonadIO m) => FontT -> Word32 -> [Text] -> m ()
- fontIsImmutable :: (HasCallStack, MonadIO m) => FontT -> m Int32
- fontMakeImmutable :: (HasCallStack, MonadIO m) => FontT -> m ()
- fontSetFace :: (HasCallStack, MonadIO m) => FontT -> FaceT -> m ()
- fontSetFuncs :: (HasCallStack, MonadIO m) => FontT -> FontFuncsT -> Ptr () -> DestroyFuncT -> m ()
- fontSetFuncsData :: (HasCallStack, MonadIO m) => FontT -> Ptr () -> DestroyFuncT -> m ()
- fontSetParent :: (HasCallStack, MonadIO m) => FontT -> FontT -> m ()
- fontSetPpem :: (HasCallStack, MonadIO m) => FontT -> Word32 -> Word32 -> m ()
- fontSetPtem :: (HasCallStack, MonadIO m) => FontT -> Float -> m ()
- fontSetScale :: (HasCallStack, MonadIO m) => FontT -> Int32 -> Int32 -> m ()
- fontSetVarCoordsDesign :: (HasCallStack, MonadIO m) => FontT -> Float -> Word32 -> m ()
- fontSetVarCoordsNormalized :: (HasCallStack, MonadIO m) => FontT -> Int32 -> Word32 -> m ()
- fontSetVarNamedInstance :: (HasCallStack, MonadIO m) => FontT -> Word32 -> m ()
- fontSetVariations :: (HasCallStack, MonadIO m) => FontT -> VariationT -> Word32 -> m ()
- fontSubtractGlyphOriginForDirection :: (HasCallStack, MonadIO m) => FontT -> Word32 -> DirectionT -> m (Int32, Int32)
- ftFontChanged :: (HasCallStack, MonadIO m) => FontT -> m ()
- ftFontGetLoadFlags :: (HasCallStack, MonadIO m) => FontT -> m Int32
- ftFontSetFuncs :: (HasCallStack, MonadIO m) => FontT -> m ()
- ftFontSetLoadFlags :: (HasCallStack, MonadIO m) => FontT -> Int32 -> m ()
- ftFontUnlockFace :: (HasCallStack, MonadIO m) => FontT -> m ()
- glibBlobCreate :: (HasCallStack, MonadIO m) => Bytes -> m BlobT
- glibGetUnicodeFuncs :: (HasCallStack, MonadIO m) => m UnicodeFuncsT
- glibScriptFromScript :: (HasCallStack, MonadIO m) => ScriptT -> m UnicodeScript
- glibScriptToScript :: (HasCallStack, MonadIO m) => UnicodeScript -> m ScriptT
- glyphInfoGetGlyphFlags :: (HasCallStack, MonadIO m) => GlyphInfoT -> m [GlyphFlagsT]
- languageFromString :: (HasCallStack, MonadIO m) => ByteString -> m LanguageT
- languageGetDefault :: (HasCallStack, MonadIO m) => m LanguageT
- languageToString :: (HasCallStack, MonadIO m) => LanguageT -> m Text
- mapAllocationSuccessful :: (HasCallStack, MonadIO m) => MapT -> m Int32
- mapClear :: (HasCallStack, MonadIO m) => MapT -> m ()
- mapCreate :: (HasCallStack, MonadIO m) => m MapT
- mapDel :: (HasCallStack, MonadIO m) => MapT -> Word32 -> m ()
- mapGet :: (HasCallStack, MonadIO m) => MapT -> Word32 -> m Word32
- mapGetEmpty :: (HasCallStack, MonadIO m) => m MapT
- mapGetPopulation :: (HasCallStack, MonadIO m) => MapT -> m Word32
- mapHas :: (HasCallStack, MonadIO m) => MapT -> Word32 -> m Int32
- mapIsEmpty :: (HasCallStack, MonadIO m) => MapT -> m Int32
- mapSet :: (HasCallStack, MonadIO m) => MapT -> Word32 -> Word32 -> m ()
- otColorGlyphGetLayers :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> Maybe [OtColorLayerT] -> m (Word32, Maybe [OtColorLayerT])
- otColorGlyphReferencePng :: (HasCallStack, MonadIO m) => FontT -> Word32 -> m BlobT
- otColorGlyphReferenceSvg :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> m BlobT
- otColorHasLayers :: (HasCallStack, MonadIO m) => FaceT -> m Int32
- otColorHasPalettes :: (HasCallStack, MonadIO m) => FaceT -> m Int32
- otColorHasPng :: (HasCallStack, MonadIO m) => FaceT -> m Int32
- otColorHasSvg :: (HasCallStack, MonadIO m) => FaceT -> m Int32
- otColorPaletteColorGetNameId :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> m Word32
- otColorPaletteGetColors :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> m (Word32, Maybe [Word32])
- otColorPaletteGetCount :: (HasCallStack, MonadIO m) => FaceT -> m Word32
- otColorPaletteGetFlags :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> m [OtColorPaletteFlagsT]
- otColorPaletteGetNameId :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> m Word32
- otFontSetFuncs :: (HasCallStack, MonadIO m) => FontT -> m ()
- otLayoutFeatureGetCharacters :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> Word32 -> [Word32] -> m (Word32, [Word32])
- otLayoutFeatureGetLookups :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> Word32 -> m (Word32, [Word32])
- otLayoutFeatureGetNameIds :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> m (Int32, Word32, Word32, Word32, Word32, Word32)
- otLayoutFeatureWithVariationsGetLookups :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> Word32 -> Word32 -> m (Word32, [Word32])
- otLayoutGetAttachPoints :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> m (Word32, [Word32])
- otLayoutGetBaseline :: (HasCallStack, MonadIO m) => FontT -> OtLayoutBaselineTagT -> DirectionT -> Word32 -> Word32 -> m (Int32, Int32)
- otLayoutGetGlyphClass :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> m OtLayoutGlyphClassT
- otLayoutGetLigatureCarets :: (HasCallStack, MonadIO m) => FontT -> DirectionT -> Word32 -> Word32 -> m (Word32, [Int32])
- otLayoutGetSizeParams :: (HasCallStack, MonadIO m) => FaceT -> m (Int32, Word32, Word32, Word32, Word32, Word32)
- otLayoutHasGlyphClasses :: (HasCallStack, MonadIO m) => FaceT -> m Int32
- otLayoutHasPositioning :: (HasCallStack, MonadIO m) => FaceT -> m Int32
- otLayoutHasSubstitution :: (HasCallStack, MonadIO m) => FaceT -> m Int32
- otLayoutLanguageFindFeature :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> Word32 -> Word32 -> m (Int32, Word32)
- otLayoutLanguageGetFeatureIndexes :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> Word32 -> Word32 -> m (Word32, [Word32])
- otLayoutLanguageGetFeatureTags :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> Word32 -> Word32 -> m (Word32, [Word32])
- otLayoutLanguageGetRequiredFeature :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> Word32 -> m (Int32, Word32, Word32)
- otLayoutLanguageGetRequiredFeatureIndex :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> Word32 -> m (Int32, Word32)
- otLayoutLookupWouldSubstitute :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> Word32 -> Int32 -> m Int32
- otLayoutScriptFindLanguage :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> Word32 -> Word32 -> m Int32
- otLayoutScriptGetLanguageTags :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> Word32 -> m (Word32, [Word32])
- otLayoutScriptSelectLanguage :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> Word32 -> Word32 -> m (Int32, Word32)
- otLayoutTableChooseScript :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> m (Int32, Word32, Word32)
- otLayoutTableFindFeatureVariations :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Int32 -> Word32 -> m (Int32, Word32)
- otLayoutTableFindScript :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> m (Int32, Word32)
- otLayoutTableGetFeatureTags :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> m (Word32, [Word32])
- otLayoutTableGetLookupCount :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> m Word32
- otLayoutTableGetScriptTags :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> m (Word32, [Word32])
- otLayoutTableSelectScript :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> Word32 -> m (Int32, Word32, Word32)
- otMathGetConstant :: (HasCallStack, MonadIO m) => FontT -> OtMathConstantT -> m Int32
- otMathGetGlyphAssembly :: (HasCallStack, MonadIO m) => FontT -> Word32 -> DirectionT -> Word32 -> [OtMathGlyphPartT] -> m (Word32, [OtMathGlyphPartT], Int32)
- otMathGetGlyphItalicsCorrection :: (HasCallStack, MonadIO m) => FontT -> Word32 -> m Int32
- otMathGetGlyphKerning :: (HasCallStack, MonadIO m) => FontT -> Word32 -> OtMathKernT -> Int32 -> m Int32
- otMathGetGlyphTopAccentAttachment :: (HasCallStack, MonadIO m) => FontT -> Word32 -> m Int32
- otMathGetGlyphVariants :: (HasCallStack, MonadIO m) => FontT -> Word32 -> DirectionT -> Word32 -> [OtMathGlyphVariantT] -> m (Word32, [OtMathGlyphVariantT])
- otMathGetMinConnectorOverlap :: (HasCallStack, MonadIO m) => FontT -> DirectionT -> m Int32
- otMathHasData :: (HasCallStack, MonadIO m) => FaceT -> m Int32
- otMathIsGlyphExtendedShape :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> m Int32
- otMetaGetEntryTags :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> OtMetaTagT -> m Word32
- otMetaReferenceEntry :: (HasCallStack, MonadIO m) => FaceT -> OtMetaTagT -> m BlobT
- otMetricsGetPosition :: (HasCallStack, MonadIO m) => FontT -> OtMetricsTagT -> m (Int32, Int32)
- otMetricsGetVariation :: (HasCallStack, MonadIO m) => FontT -> OtMetricsTagT -> m Float
- otMetricsGetXVariation :: (HasCallStack, MonadIO m) => FontT -> OtMetricsTagT -> m Int32
- otMetricsGetYVariation :: (HasCallStack, MonadIO m) => FontT -> OtMetricsTagT -> m Int32
- otNameGetUtf16 :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> LanguageT -> [Word16] -> m (Word32, [Word16])
- otNameGetUtf32 :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> LanguageT -> [Word32] -> m (Word32, [Word32])
- otNameGetUtf8 :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> LanguageT -> [Text] -> m (Word32, [Text])
- otNameListNames :: (HasCallStack, MonadIO m) => FaceT -> m [OtNameEntryT]
- otShapeGlyphsClosure :: (HasCallStack, MonadIO m) => FontT -> BufferT -> FeatureT -> Word32 -> SetT -> m ()
- otTagFromLanguage :: (HasCallStack, MonadIO m) => LanguageT -> m Word32
- otTagToLanguage :: (HasCallStack, MonadIO m) => Word32 -> m LanguageT
- otTagToScript :: (HasCallStack, MonadIO m) => Word32 -> m ScriptT
- otTagsFromScript :: (HasCallStack, MonadIO m) => ScriptT -> Word32 -> Word32 -> m ()
- otTagsFromScriptAndLanguage :: (HasCallStack, MonadIO m) => ScriptT -> LanguageT -> Word32 -> Word32 -> m (Word32, Word32)
- otTagsToScriptAndLanguage :: (HasCallStack, MonadIO m) => Word32 -> Word32 -> ScriptT -> Maybe LanguageT -> m ()
- otVarFindAxis :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> OtVarAxisT -> m Int32
- otVarFindAxisInfo :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> OtVarAxisInfoT -> m Int32
- otVarGetAxes :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> OtVarAxisT -> m Word32
- otVarGetAxisCount :: (HasCallStack, MonadIO m) => FaceT -> m Word32
- otVarGetAxisInfos :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> OtVarAxisInfoT -> m Word32
- otVarGetNamedInstanceCount :: (HasCallStack, MonadIO m) => FaceT -> m Word32
- otVarHasData :: (HasCallStack, MonadIO m) => FaceT -> m Int32
- otVarNamedInstanceGetDesignCoords :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> Float -> m Word32
- otVarNamedInstanceGetPostscriptNameId :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> m Word32
- otVarNamedInstanceGetSubfamilyNameId :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> m Word32
- otVarNormalizeCoords :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Float -> Int32 -> m ()
- otVarNormalizeVariations :: (HasCallStack, MonadIO m) => FaceT -> VariationT -> Word32 -> Int32 -> Word32 -> m ()
- scriptFromIso15924Tag :: (HasCallStack, MonadIO m) => Word32 -> m ScriptT
- scriptFromString :: (HasCallStack, MonadIO m) => ByteString -> m ScriptT
- scriptGetHorizontalDirection :: (HasCallStack, MonadIO m) => ScriptT -> m DirectionT
- scriptToIso15924Tag :: (HasCallStack, MonadIO m) => ScriptT -> m Word32
- segmentPropertiesEqual :: (HasCallStack, MonadIO m) => SegmentPropertiesT -> SegmentPropertiesT -> m Int32
- segmentPropertiesHash :: (HasCallStack, MonadIO m) => SegmentPropertiesT -> m Word32
- setAdd :: (HasCallStack, MonadIO m) => SetT -> Word32 -> m ()
- setAddRange :: (HasCallStack, MonadIO m) => SetT -> Word32 -> Word32 -> m ()
- setAllocationSuccessful :: (HasCallStack, MonadIO m) => SetT -> m Int32
- setClear :: (HasCallStack, MonadIO m) => SetT -> m ()
- setCreate :: (HasCallStack, MonadIO m) => m SetT
- setDel :: (HasCallStack, MonadIO m) => SetT -> Word32 -> m ()
- setDelRange :: (HasCallStack, MonadIO m) => SetT -> Word32 -> Word32 -> m ()
- setGetEmpty :: (HasCallStack, MonadIO m) => m SetT
- setGetMax :: (HasCallStack, MonadIO m) => SetT -> m Word32
- setGetMin :: (HasCallStack, MonadIO m) => SetT -> m Word32
- setGetPopulation :: (HasCallStack, MonadIO m) => SetT -> m Word32
- setHas :: (HasCallStack, MonadIO m) => SetT -> Word32 -> m Int32
- setIntersect :: (HasCallStack, MonadIO m) => SetT -> SetT -> m ()
- setInvert :: (HasCallStack, MonadIO m) => SetT -> m ()
- setIsEmpty :: (HasCallStack, MonadIO m) => SetT -> m Int32
- setIsEqual :: (HasCallStack, MonadIO m) => SetT -> SetT -> m Int32
- setIsSubset :: (HasCallStack, MonadIO m) => SetT -> SetT -> m Int32
- setNext :: (HasCallStack, MonadIO m) => SetT -> Word32 -> m (Int32, Word32)
- setNextRange :: (HasCallStack, MonadIO m) => SetT -> Word32 -> m (Int32, Word32, Word32)
- setPrevious :: (HasCallStack, MonadIO m) => SetT -> Word32 -> m (Int32, Word32)
- setPreviousRange :: (HasCallStack, MonadIO m) => SetT -> Word32 -> m (Int32, Word32, Word32)
- setSet :: (HasCallStack, MonadIO m) => SetT -> SetT -> m ()
- setSubtract :: (HasCallStack, MonadIO m) => SetT -> SetT -> m ()
- setSymmetricDifference :: (HasCallStack, MonadIO m) => SetT -> SetT -> m ()
- setUnion :: (HasCallStack, MonadIO m) => SetT -> SetT -> m ()
- shape :: (HasCallStack, MonadIO m) => FontT -> BufferT -> Maybe [FeatureT] -> m ()
- shapeFull :: (HasCallStack, MonadIO m) => FontT -> BufferT -> Maybe [FeatureT] -> Maybe [Text] -> m Int32
- shapeListShapers :: (HasCallStack, MonadIO m) => m [Text]
- shapePlanCreate :: (HasCallStack, MonadIO m) => FaceT -> SegmentPropertiesT -> [FeatureT] -> [Text] -> m ShapePlanT
- shapePlanCreate2 :: (HasCallStack, MonadIO m) => FaceT -> SegmentPropertiesT -> FeatureT -> Word32 -> Int32 -> Word32 -> Text -> m ShapePlanT
- shapePlanCreateCached :: (HasCallStack, MonadIO m) => FaceT -> SegmentPropertiesT -> [FeatureT] -> [Text] -> m ShapePlanT
- shapePlanCreateCached2 :: (HasCallStack, MonadIO m) => FaceT -> SegmentPropertiesT -> FeatureT -> Word32 -> Int32 -> Word32 -> Text -> m ShapePlanT
- shapePlanExecute :: (HasCallStack, MonadIO m) => ShapePlanT -> FontT -> BufferT -> [FeatureT] -> m Int32
- shapePlanGetEmpty :: (HasCallStack, MonadIO m) => m ShapePlanT
- shapePlanGetShaper :: (HasCallStack, MonadIO m) => ShapePlanT -> m Text
- tagFromString :: (HasCallStack, MonadIO m) => ByteString -> m Word32
- unicodeCombiningClass :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> Word32 -> m UnicodeCombiningClassT
- unicodeCompose :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> Word32 -> Word32 -> m (Int32, Word32)
- unicodeDecompose :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> Word32 -> m (Int32, Word32, Word32)
- unicodeDecomposeCompatibility :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> Word32 -> m (Word32, Word32)
- unicodeEastasianWidth :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> Word32 -> m Word32
- unicodeFuncsCreate :: (HasCallStack, MonadIO m) => Maybe UnicodeFuncsT -> m UnicodeFuncsT
- unicodeFuncsGetDefault :: (HasCallStack, MonadIO m) => m UnicodeFuncsT
- unicodeFuncsGetEmpty :: (HasCallStack, MonadIO m) => m UnicodeFuncsT
- unicodeFuncsGetParent :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> m UnicodeFuncsT
- unicodeFuncsIsImmutable :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> m Int32
- unicodeFuncsMakeImmutable :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> m ()
- unicodeFuncsSetCombiningClassFunc :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> UnicodeCombiningClassFuncT -> m ()
- unicodeFuncsSetComposeFunc :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> UnicodeComposeFuncT -> m ()
- unicodeFuncsSetDecomposeCompatibilityFunc :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> UnicodeDecomposeCompatibilityFuncT -> m ()
- unicodeFuncsSetDecomposeFunc :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> UnicodeDecomposeFuncT -> m ()
- unicodeFuncsSetEastasianWidthFunc :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> UnicodeEastasianWidthFuncT -> m ()
- unicodeFuncsSetGeneralCategoryFunc :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> UnicodeGeneralCategoryFuncT -> m ()
- unicodeFuncsSetMirroringFunc :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> UnicodeMirroringFuncT -> m ()
- unicodeFuncsSetScriptFunc :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> UnicodeScriptFuncT -> m ()
- unicodeGeneralCategory :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> Word32 -> m UnicodeGeneralCategoryT
- unicodeMirroring :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> Word32 -> m Word32
- unicodeScript :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> Word32 -> m ScriptT
- variationFromString :: (HasCallStack, MonadIO m) => Text -> Int32 -> VariationT -> m Int32
- variationToString :: (HasCallStack, MonadIO m) => VariationT -> Text -> Word32 -> m ()
- version :: (HasCallStack, MonadIO m) => m (Word32, Word32, Word32)
- versionAtleast :: (HasCallStack, MonadIO m) => Word32 -> Word32 -> Word32 -> m Int32
- versionString :: (HasCallStack, MonadIO m) => m Text

# Methods

## blobCopyWritableOrFail

blobCopyWritableOrFail Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BlobT | `blob`: A blob.
-> m BlobT | Returns: New blob, or nullptr if allocation failed.

Makes a writable copy of `blob`.

Since: 1.8.0

## blobCreateFromFile

blobCreateFromFile Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Text | `fileName`: font filename.
-> m BlobT | Returns: A hb_blob_t pointer with the content of the file

No description available in the introspection data.

Since: 1.7.7

## blobCreateSubBlob

blobCreateSubBlob Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BlobT | `parent`: Parent blob.
-> Word32 | `offset`: Start offset of sub-blob within `parent`, in bytes.
-> Word32 | `length`: Length of sub-blob.
-> m BlobT | Returns: New blob, or the empty blob if something failed or if `length` is zero or `offset` is beyond the end of `parent`'s data. Destroy with `hb_blob_destroy()`.

Returns a blob that represents a range of bytes in `parent`. The new blob is always created with `MemoryModeTReadonly`, meaning that it will never modify data in the parent blob. The parent data is not expected to be modified, and will result in undefined behavior if it is.

Makes `parent` immutable.

Since: 0.9.2

## blobGetData

blobGetData Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BlobT | `blob`: a blob.
-> m [Text] |

No description available in the introspection data.

Since: 0.9.2

## blobGetDataWritable

blobGetDataWritable Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BlobT | `blob`: a blob.
-> m [Text] | Returns: Writable blob data, or `Nothing` if failed.

Tries to make blob data writable (possibly copying it) and return pointer to data.

Fails if blob has been made immutable, or if memory allocation fails.

Since: 0.9.2

## blobGetEmpty

blobGetEmpty Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m BlobT | Returns: the empty blob.

Returns the singleton empty blob.

See TODO:link object types for more information.

Since: 0.9.2

## blobGetLength

blobGetLength Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BlobT | `blob`: a blob.
-> m Word32 | Returns: the length of blob data in bytes.

No description available in the introspection data.

Since: 0.9.2

## blobIsImmutable

blobIsImmutable Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BlobT | `blob`: a blob.
-> m Int32 | Returns: TODO

No description available in the introspection data.

Since: 0.9.2

## blobMakeImmutable

blobMakeImmutable Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BlobT | `blob`: a blob.
-> m () |

No description available in the introspection data.

Since: 0.9.2

## bufferAdd

bufferAdd Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> Word32 | `codepoint`: a Unicode code point.
-> Word32 | `cluster`: the cluster value of `codepoint`.
-> m () |

Appends a character with the Unicode value of `codepoint` to `buffer`, and gives it the initial cluster value of `cluster`. Clusters can be any thing the client wants, they are usually used to refer to the index of the character in the input text stream and are output in `GlyphInfoT`.`cluster` field.

This function does not check the validity of `codepoint`, it is up to the caller to ensure it is a valid Unicode code point.

Since: 0.9.7

## bufferAddCodepoints

bufferAddCodepoints Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: a `BufferT` to append characters to.
-> [Word32] | `text`: an array of Unicode code points to append.
-> Word32 | `itemOffset`: the offset of the first code point to add to the `buffer`.
-> Int32 | `itemLength`: the number of code points to add to the `buffer`, or -1 for the end of `text` (assuming it is `Nothing` terminated).
-> m () |

Appends characters from `text` array to `buffer`. The `itemOffset` is the position of the first character from `text` that will be appended, and `itemLength` is the number of character. When shaping part of a larger text (e.g. a run of text from a paragraph), instead of passing just the substring corresponding to the run, it is preferable to pass the whole paragraph and specify the run start and length as `itemOffset` and `itemLength`, respectively, to give HarfBuzz the full context to be able, for example, to do cross-run Arabic shaping or properly handle combining marks at stat of run.

This function does not check the validity of `text`, it is up to the caller to ensure it contains a valid Unicode code points.

Since: 0.9.31

## bufferAddLatin1

bufferAddLatin1 Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> ByteString | `text`: an array of UTF-8 characters to append.
-> Word32 | `itemOffset`: the offset of the first character to add to the `buffer`.
-> Int32 | `itemLength`: the number of characters to add to the `buffer`, or -1 for the end of `text` (assuming it is `Nothing` terminated).
-> m () |

Similar to `bufferAddCodepoints`, but allows only access to first 256 Unicode code points that can fit in 8-bit strings.

<note>Has nothing to do with non-Unicode Latin-1 encoding.</note>

Since: 0.9.39

## bufferAddUtf16

bufferAddUtf16 Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> [Word16] | `text`: an array of UTF-16 characters to append.
-> Word32 | `itemOffset`: the offset of the first character to add to the `buffer`.
-> Int32 | `itemLength`: the number of characters to add to the `buffer`, or -1 for the end of `text` (assuming it is `Nothing` terminated).
-> m () |

See `bufferAddCodepoints`.

Replaces invalid UTF-16 characters with the `buffer` replacement code point, see `bufferSetReplacementCodepoint`.

Since: 0.9.2

## bufferAddUtf32

bufferAddUtf32 Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> [Word32] | `text`: an array of UTF-32 characters to append.
-> Word32 | `itemOffset`: the offset of the first character to add to the `buffer`.
-> Int32 | `itemLength`: the number of characters to add to the `buffer`, or -1 for the end of `text` (assuming it is `Nothing` terminated).
-> m () |

See `bufferAddCodepoints`.

Replaces invalid UTF-32 characters with the `buffer` replacement code point, see `bufferSetReplacementCodepoint`.

Since: 0.9.2

## bufferAddUtf8

bufferAddUtf8 Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> ByteString | `text`: an array of UTF-8 characters to append.
-> Word32 | `itemOffset`: the offset of the first character to add to the `buffer`.
-> Int32 | `itemLength`: the number of characters to add to the `buffer`, or -1 for the end of `text` (assuming it is `Nothing` terminated).
-> m () |

See `bufferAddCodepoints`.

Replaces invalid UTF-8 characters with the `buffer` replacement code point, see `bufferSetReplacementCodepoint`.

Since: 0.9.2

## bufferAllocationSuccessful

bufferAllocationSuccessful Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> m Int32 | Returns: `true` if `buffer` memory allocation succeeded, `false` otherwise.

Check if allocating memory for the buffer succeeded.

Since: 0.9.2

## bufferAppend

bufferAppend Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> BufferT | `source`: source `BufferT`.
-> Word32 | `start`: start index into source buffer to copy. Use 0 to copy from start of buffer.
-> Word32 | `end`: end index into source buffer to copy. Use `hBFEATUREGLOBALEND` to copy to end of buffer.
-> m () |

Append (part of) contents of another buffer to this buffer.

Since: 1.5.0

## bufferClearContents

bufferClearContents Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> m () |

Similar to `bufferReset`, but does not clear the Unicode functions and the replacement code point.

Since: 0.9.11

## bufferCreate

bufferCreate Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m BufferT | Returns: A newly allocated `BufferT` with a reference count of 1. The initial reference count should be released with `hb_buffer_destroy()` when you are done using the `BufferT`. This function never returns `Nothing`. If memory cannot be allocated, a special `BufferT` object will be returned on which `bufferAllocationSuccessful` returns `false`.

Creates a new `BufferT` with all properties to defaults.

Since: 0.9.2

## bufferDeserializeGlyphs

bufferDeserializeGlyphs Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT` buffer.
-> [Text] |
-> FontT |
-> BufferSerializeFormatT |
-> m (Int32, Text) |

No description available in the introspection data.

Since: 0.9.7

## bufferDiff

bufferDiff Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: a buffer.
-> BufferT | `reference`: other buffer to compare to.
-> Word32 | `dottedcircleGlyph`: glyph id of U+25CC DOTTED CIRCLE, or (hb_codepont_t) -1.
-> Word32 | `positionFuzz`: allowed absolute difference in position values.
-> m [BufferDiffFlagsT] |

If dottedcircle_glyph is (hb_codepoint_t) -1 then `BufferDiffFlagsTDottedCirclePresent` and `BufferDiffFlagsTNotdefPresent` are never returned. This should be used by most callers if just comparing two buffers is needed.

Since: 1.5.0

## bufferGetClusterLevel

bufferGetClusterLevel Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> m BufferClusterLevelT |

No description available in the introspection data.

Since: 0.9.42

## bufferGetContentType

bufferGetContentType Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> m BufferContentTypeT | Returns: The type of `buffer` contents.

see `bufferSetContentType`.

Since: 0.9.5

## bufferGetDirection

bufferGetDirection Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> m DirectionT | Returns: The direction of the `buffer`.

See `bufferSetDirection`

Since: 0.9.2

## bufferGetEmpty

bufferGetEmpty :: (HasCallStack, MonadIO m) => m BufferT Source #

No description available in the introspection data.

Since: 0.9.2

## bufferGetFlags

bufferGetFlags Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> m [BufferFlagsT] | Returns: The `buffer` flags.

See `bufferSetFlags`.

Since: 0.9.7

## bufferGetGlyphInfos

bufferGetGlyphInfos Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> m [GlyphInfoT] | Returns: The `buffer` glyph information array. The value valid as long as buffer has not been modified.

Returns `buffer` glyph information array. Returned pointer is valid as long as `buffer` contents are not modified.

Since: 0.9.2

## bufferGetGlyphPositions

bufferGetGlyphPositions Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> m [GlyphPositionT] | Returns: The `buffer` glyph position array. The value valid as long as buffer has not been modified.

Returns `buffer` glyph position array. Returned pointer is valid as long as `buffer` contents are not modified.

Since: 0.9.2

## bufferGetInvisibleGlyph

bufferGetInvisibleGlyph Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> m Word32 | Returns: The `buffer` invisible `hb_codepoint_t`.

See `bufferSetInvisibleGlyph`.

Since: 2.0.0

## bufferGetLanguage

bufferGetLanguage Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> m LanguageT | Returns: The `LanguageT` of the buffer. Must not be freed by the caller.

See `bufferSetLanguage`.

Since: 0.9.2

## bufferGetLength

bufferGetLength Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> m Word32 | Returns: The `buffer` length. The value valid as long as buffer has not been modified.

Returns the number of items in the buffer.

Since: 0.9.2

## bufferGetReplacementCodepoint

bufferGetReplacementCodepoint Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> m Word32 | Returns: The `buffer` replacement `hb_codepoint_t`.

See `bufferSetReplacementCodepoint`.

Since: 0.9.31

## bufferGetScript

bufferGetScript Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> m ScriptT | Returns: The `ScriptT` of the `buffer`.

See `bufferSetScript`.

Since: 0.9.2

## bufferGetSegmentProperties

bufferGetSegmentProperties Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> m SegmentPropertiesT |

Sets `props` to the `SegmentPropertiesT` of `buffer`.

Since: 0.9.7

## bufferGetUnicodeFuncs

bufferGetUnicodeFuncs Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> m UnicodeFuncsT |

No description available in the introspection data.

Since: 0.9.2

## bufferGuessSegmentProperties

bufferGuessSegmentProperties Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> m () |

Sets unset buffer segment properties based on buffer Unicode contents. If buffer is not empty, it must have content type `BufferContentTypeTUnicode`.

If buffer script is not set (ie. is `ScriptTInvalid`), it will be set to the Unicode script of the first character in the buffer that has a script other than `ScriptTCommon`, `ScriptTInherited`, and `ScriptTUnknown`.

Next, if buffer direction is not set (ie. is `DirectionTInvalid`), it will be set to the natural horizontal direction of the buffer script as returned by `scriptGetHorizontalDirection`. If `scriptGetHorizontalDirection` returns `DirectionTInvalid`, then `DirectionTLtr` is used.

Finally, if buffer language is not set (ie. is `LANGUAGE_INVALID`), it will be set to the process's default language as returned by `languageGetDefault`. This may change in the future by taking buffer script into consideration when choosing a language. Note that `languageGetDefault` is NOT threadsafe the first time it is called. See documentation for that function for details.

Since: 0.9.7

## bufferNormalizeGlyphs

bufferNormalizeGlyphs Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> m () |

Reorders a glyph buffer to have canonical in-cluster glyph order / position. The resulting clusters should behave identical to pre-reordering clusters.

<note>This has nothing to do with Unicode normalization.</note>

Since: 0.9.2

## bufferPreAllocate

bufferPreAllocate Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> Word32 | `size`: number of items to pre allocate.
-> m Int32 | Returns: `true` if `buffer` memory allocation succeeded, `false` otherwise.

Pre allocates memory for `buffer` to fit at least `size` number of items.

Since: 0.9.2

## bufferReset

bufferReset Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> m () |

Resets the buffer to its initial status, as if it was just newly created with `bufferCreate`.

Since: 0.9.2

## bufferReverse

bufferReverse Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> m () |

Reverses buffer contents.

Since: 0.9.2

## bufferReverseClusters

bufferReverseClusters Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> m () |

Reverses buffer clusters. That is, the buffer contents are reversed, then each cluster (consecutive items having the same cluster number) are reversed again.

Since: 0.9.2

## bufferReverseRange

bufferReverseRange Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> Word32 | `start`: start index.
-> Word32 | `end`: end index.
-> m () |

Reverses buffer contents between start to end.

Since: 0.9.41

## bufferSerializeFormatFromString

bufferSerializeFormatFromString Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> ByteString | `str`: a string to parse
-> m BufferSerializeFormatT | Returns: The parsed `BufferSerializeFormatT`.

Parses a string into an `BufferSerializeFormatT`. Does not check if `str` is a valid buffer serialization format, use `bufferSerializeListFormats` to get the list of supported formats.

Since: 0.9.7

## bufferSerializeFormatToString

bufferSerializeFormatToString Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferSerializeFormatT | `format`: an `BufferSerializeFormatT` to convert.
-> m Text | Returns: A `Nothing` terminated string corresponding to `format`. Should not be freed.

Converts `format` to the string corresponding it, or `Nothing` if it is not a valid `BufferSerializeFormatT`.

Since: 0.9.7

## bufferSerializeGlyphs

bufferSerializeGlyphs Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT` buffer.
-> Word32 | `start`: the first item in `buffer` to serialize.
-> Word32 | `end`: the last item in `buffer` to serialize.
-> Maybe FontT | `font`: the `FontT` used to shape this buffer, needed to read glyph names and extents. If `Nothing`, and empty font will be used.
-> BufferSerializeFormatT | `format`: the `BufferSerializeFormatT` to use for formatting the output.
-> [BufferSerializeFlagsT] | `flags`: the `BufferSerializeFlagsT` that control what glyph properties to serialize.
-> m (Word32, ByteString, Word32) | Returns: The number of serialized items.

Serializes `buffer` into a textual representation of its glyph content, useful for showing the contents of the buffer, for example during debugging. There are currently two supported serialization formats:

## text

A human-readable, plain text format. The serialized glyphs will look something like:

```[uni0651=0@518,0+0|uni0628=0+1897]` ``- The serialized glyphs are delimited with` [`and` ]`. - Glyphs are separated with` |`- Each glyph starts with glyph name, or glyph index if #HB_BUFFER_SERIALIZE_FLAG_NO_GLYPH_NAMES flag is set. Then, - If #HB_BUFFER_SERIALIZE_FLAG_NO_CLUSTERS is not set,` =`then #hb_glyph_info_t.cluster. - If hb_glyph_position_t in the format: - If both hb_glyph_position_t.y_offset are not 0,` `xOffset`,y_offset`. Then, -` +x_advance`, then` ,y_advance`if #hb_glyph_position_t.y_advance is not 0. Then, - If #HB_BUFFER_SERIALIZE_FLAG_GLYPH_EXTENTS is set, the #hb_glyph_extents_t in the format` &lt;x_bearing,y_bearing,width,height&gt;`

## json

TODO.

Since: 0.9.7

## bufferSerializeListFormats

bufferSerializeListFormats Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m [Text] | Returns: A string array of buffer serialization formats. Should not be freed.

Returns a list of supported buffer serialization formats.

Since: 0.9.7

## bufferSetClusterLevel

bufferSetClusterLevel Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> BufferClusterLevelT |
-> m () |

No description available in the introspection data.

Since: 0.9.42

## bufferSetContentType

bufferSetContentType Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> BufferContentTypeT | `contentType`: the type of buffer contents to set
-> m () |

Sets the type of `buffer` contents, buffers are either empty, contain characters (before shaping) or glyphs (the result of shaping).

Since: 0.9.5

## bufferSetDirection

bufferSetDirection Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> DirectionT | `direction`: the `DirectionT` of the `buffer`
-> m () |

Set the text flow direction of the buffer. No shaping can happen without setting `buffer` direction, and it controls the visual direction for the output glyphs; for RTL direction the glyphs will be reversed. Many layout features depend on the proper setting of the direction, for example, reversing RTL text before shaping, then shaping with LTR direction is not the same as keeping the text in logical order and shaping with RTL direction.

Since: 0.9.2

## bufferSetFlags

bufferSetFlags Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> [BufferFlagsT] | `flags`: the buffer flags to set.
-> m () |

Sets `buffer` flags to `flags`. See `BufferFlagsT`.

Since: 0.9.7

## bufferSetInvisibleGlyph

bufferSetInvisibleGlyph Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> Word32 | `invisible`: the invisible `hb_codepoint_t`
-> m () |

Sets the `hb_codepoint_t` that replaces invisible characters in the shaping result. If set to zero (default), the glyph for the U+0020 SPACE character is used. Otherwise, this value is used verbatim.

Since: 2.0.0

## bufferSetLanguage

bufferSetLanguage Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> LanguageT | `language`: an hb_language_t to set.
-> m () |

Sets the language of `buffer` to `language`.

Languages are crucial for selecting which OpenType feature to apply to the buffer which can result in applying language-specific behaviour. Languages are orthogonal to the scripts, and though they are related, they are different concepts and should not be confused with each other.

Use `languageFromString` to convert from BCP 47 language tags to `LanguageT`.

Since: 0.9.2

## bufferSetLength

bufferSetLength Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> Word32 | `length`: the new length of `buffer`.
-> m Int32 | Returns: `true` if `buffer` memory allocation succeeded, `false` otherwise.

Similar to `bufferPreAllocate`, but clears any new items added at the end.

Since: 0.9.2

## bufferSetMessageFunc

bufferSetMessageFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> BufferMessageFuncT |
-> m () |

No description available in the introspection data.

Since: 1.1.3

## bufferSetReplacementCodepoint

bufferSetReplacementCodepoint Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> Word32 | `replacement`: the replacement `hb_codepoint_t`
-> m () |

Sets the `hb_codepoint_t` that replaces invalid entries for a given encoding when adding text to `buffer`.

Default is `BUFFER_REPLACEMENT_CODEPOINT_DEFAULT`.

Since: 0.9.31

## bufferSetScript

bufferSetScript Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> ScriptT | `script`: an `ScriptT` to set.
-> m () |

Sets the script of `buffer` to `script`.

Script is crucial for choosing the proper shaping behaviour for scripts that require it (e.g. Arabic) and the which OpenType features defined in the font to be applied.

You can pass one of the predefined `ScriptT` values, or use `scriptFromString` or `scriptFromIso15924Tag` to get the corresponding script from an ISO 15924 script tag.

Since: 0.9.2

## bufferSetSegmentProperties

bufferSetSegmentProperties Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> SegmentPropertiesT | `props`: an `SegmentPropertiesT` to use.
-> m () |

Sets the segment properties of the buffer, a shortcut for calling `bufferSetDirection`, `bufferSetScript` and `bufferSetLanguage` individually.

Since: 0.9.7

## bufferSetUnicodeFuncs

bufferSetUnicodeFuncs Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BufferT | `buffer`: an `BufferT`.
-> UnicodeFuncsT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## colorGetAlpha

colorGetAlpha Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Word32 |
-> m Word8 | Returns: Alpha channel value of the given color

color: a `hb_color_t` we are interested in its channels.

Since: 2.1.0

## colorGetBlue

colorGetBlue Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Word32 |
-> m Word8 | Returns: Blue channel value of the given color

color: a `hb_color_t` we are interested in its channels.

Since: 2.1.0

## colorGetGreen

colorGetGreen Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Word32 |
-> m Word8 | Returns: Green channel value of the given color

color: a `hb_color_t` we are interested in its channels.

Since: 2.1.0

## colorGetRed

colorGetRed Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Word32 |
-> m Word8 | Returns: Red channel value of the given color

color: a `hb_color_t` we are interested in its channels.

Since: 2.1.0

## directionFromString

directionFromString :: (HasCallStack, MonadIO m) => ByteString -> m DirectionT Source #

No description available in the introspection data.

Since: 0.9.2

## directionToString

directionToString :: (HasCallStack, MonadIO m) => DirectionT -> m Text Source #

No description available in the introspection data.

Since: 0.9.2

## faceBuilderAddTable

faceBuilderAddTable :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> BlobT -> m Int32 Source #

Add table for `tag` with data provided by `blob` to the face. `face` must be created using `faceBuilderCreate`.

Since: 1.9.0

## faceBuilderCreate

faceBuilderCreate Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m FaceT | Returns: New face.

Creates a `FaceT` that can be used with `faceBuilderAddTable`. After tables are added to the face, it can be compiled to a binary font file by calling `faceReferenceBlob`.

Since: 1.9.0

## faceCollectUnicodes

faceCollectUnicodes Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: font face.
-> SetT | `out`: set to add Unicode characters covered by `face` to.
-> m () |

No description available in the introspection data.

Since: 1.9.0

## faceCollectVariationSelectors

faceCollectVariationSelectors Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: font face.
-> SetT | `out`: set to add Variation Selector characters covered by `face` to.
-> m () |

No description available in the introspection data.

Since: 1.9.0

## faceCollectVariationUnicodes

faceCollectVariationUnicodes Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: font face.
-> Word32 |
-> SetT | `out`: set to add Unicode characters for `variationSelector` covered by `face` to.
-> m () |

No description available in the introspection data.

Since: 1.9.0

## faceCount

faceCount Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> BlobT | `blob`: a blob.
-> m Word32 | Returns: Number of faces in `blob`

Get number of faces in a blob.

Since: 1.7.7

## faceCreate

faceCreate :: (HasCallStack, MonadIO m) => BlobT -> Word32 -> m FaceT Source #

No description available in the introspection data.

Since: 0.9.2

## faceCreateForTables

faceCreateForTables :: (HasCallStack, MonadIO m) => ReferenceTableFuncT -> m FaceT Source #

No description available in the introspection data.

Since: 0.9.2

## faceGetEmpty

faceGetEmpty :: (HasCallStack, MonadIO m) => m FaceT Source #

No description available in the introspection data.

Since: 0.9.2

## faceGetGlyphCount

faceGetGlyphCount Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: a face.
-> m Word32 |

No description available in the introspection data.

Since: 0.9.7

## faceGetIndex

faceGetIndex Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: a face.
-> m Word32 |

No description available in the introspection data.

Since: 0.9.2

## faceGetTableTags

faceGetTableTags Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: a face.
-> Word32 | `startOffset`: index of first tag to return.
-> Word32 | `tableCount`: input length of `tableTags` array, output number of items written.
-> Word32 | `tableTags`: array to write tags into.
-> m Word32 | Returns: total number of tables, or 0 if not possible to list.

Retrieves table tags for a face, if possible.

Since: 1.6.0

## faceGetUpem

faceGetUpem Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: a face.
-> m Word32 |

No description available in the introspection data.

Since: 0.9.2

## faceIsImmutable

faceIsImmutable Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: a face.
-> m Int32 |

No description available in the introspection data.

Since: 0.9.2

## faceMakeImmutable

faceMakeImmutable Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: a face.
-> m () |

No description available in the introspection data.

Since: 0.9.2

## faceReferenceBlob

faceReferenceBlob Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: a face.
-> m BlobT |

No description available in the introspection data.

Since: 0.9.2

## faceReferenceTable

faceReferenceTable Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: a face.
-> Word32 |
-> m BlobT |

No description available in the introspection data.

Since: 0.9.2

## faceSetGlyphCount

faceSetGlyphCount Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: a face.
-> Word32 |
-> m () |

No description available in the introspection data.

Since: 0.9.7

## faceSetIndex

faceSetIndex Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: a face.
-> Word32 |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## faceSetUpem

faceSetUpem Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: a face.
-> Word32 |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## featureFromString

featureFromString Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> ByteString | `str`: a string to parse
-> m (Int32, FeatureT) | Returns: `true` if `str` is successfully parsed, `false` otherwise.

Parses a string into a `FeatureT`.

The format for specifying feature strings follows. All valid CSS font-feature-settings values other than 'normal' and the global values are also accepted, though not documented below. CSS string escapes are not supported.

The range indices refer to the positions between Unicode characters. The position before the first character is always 0.

The format is Python-esque. Here is how it all works:

<informaltable pgwide='1' align='left' frame='none'> <tgroup cols='5'> <thead> <row><entry>Syntax</entry> <entry>Value</entry> <entry>Start</entry> <entry>End</entry></row> </thead> <tbody> <row><entry>Setting value:</entry></row> <row><entry>kern</entry> <entry>1</entry> <entry>0</entry> <entry>∞</entry> <entry>Turn feature on</entry></row> <row><entry>+kern</entry> <entry>1</entry> <entry>0</entry> <entry>∞</entry> <entry>Turn feature on</entry></row> <row><entry>-kern</entry> <entry>0</entry> <entry>0</entry> <entry>∞</entry> <entry>Turn feature off</entry></row> <row><entry>kern=0</entry> <entry>0</entry> <entry>0</entry> <entry>∞</entry> <entry>Turn feature off</entry></row> <row><entry>kern=1</entry> <entry>1</entry> <entry>0</entry> <entry>∞</entry> <entry>Turn feature on</entry></row> <row><entry>aalt=2</entry> <entry>2</entry> <entry>0</entry> <entry>∞</entry> <entry>Choose 2nd alternate</entry></row> <row><entry>Setting index:</entry></row> <row><entry>kern[]</entry> <entry>1</entry> <entry>0</entry> <entry>∞</entry> <entry>Turn feature on</entry></row> <row><entry>kern[:]</entry> <entry>1</entry> <entry>0</entry> <entry>∞</entry> <entry>Turn feature on</entry></row> <row><entry>kern[5:]</entry> <entry>1</entry> <entry>5</entry> <entry>∞</entry> <entry>Turn feature on, partial</entry></row> <row><entry>kern[:5]</entry> <entry>1</entry> <entry>0</entry> <entry>5</entry> <entry>Turn feature on, partial</entry></row> <row><entry>kern[3:5]</entry> <entry>1</entry> <entry>3</entry> <entry>5</entry> <entry>Turn feature on, range</entry></row> <row><entry>kern[3]</entry> <entry>1</entry> <entry>3</entry> <entry>3+1</entry> <entry>Turn feature on, single char</entry></row> <row><entry>Mixing it all:</entry></row> <row><entry>aalt[3:5]=2</entry> <entry>2</entry> <entry>3</entry> <entry>5</entry> <entry>Turn 2nd alternate on for range</entry></row> </tbody> </tgroup> </informaltable>

Since: 0.9.5

## featureToString

featureToString Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FeatureT | `feature`: an `FeatureT` to convert
-> m [Text] |

Converts a `FeatureT` into a `Nothing`-terminated string in the format understood by `featureFromString`. The client in responsible for allocating big enough size for `buf`, 128 bytes is more than enough.

Since: 0.9.5

## fontAddGlyphOriginForDirection

fontAddGlyphOriginForDirection Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> DirectionT |
-> m (Int32, Int32) |

No description available in the introspection data.

Since: 0.9.2

## fontCreate

fontCreate Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: a face.
-> m FontT |

No description available in the introspection data.

Since: 0.9.2

## fontCreateSubFont

fontCreateSubFont Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `parent`: parent font.
-> m FontT |

No description available in the introspection data.

Since: 0.9.2

## fontFuncsCreate

fontFuncsCreate :: (HasCallStack, MonadIO m) => m FontFuncsT Source #

No description available in the introspection data.

Since: 0.9.2

## fontFuncsGetEmpty

fontFuncsGetEmpty :: (HasCallStack, MonadIO m) => m FontFuncsT Source #

No description available in the introspection data.

Since: 0.9.2

## fontFuncsIsImmutable

fontFuncsIsImmutable Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontFuncsT | `ffuncs`: font functions.
-> m Int32 |

No description available in the introspection data.

Since: 0.9.2

## fontFuncsMakeImmutable

fontFuncsMakeImmutable Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontFuncsT | `ffuncs`: font functions.
-> m () |

No description available in the introspection data.

Since: 0.9.2

## fontFuncsSetFontHExtentsFunc

fontFuncsSetFontHExtentsFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontFuncsT | `ffuncs`: font functions.
-> FontGetFontExtentsFuncT |
-> m () |

No description available in the introspection data.

Since: 1.1.2

## fontFuncsSetFontVExtentsFunc

fontFuncsSetFontVExtentsFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontFuncsT | `ffuncs`: font functions.
-> FontGetFontExtentsFuncT |
-> m () |

No description available in the introspection data.

Since: 1.1.2

## fontFuncsSetGlyphContourPointFunc

fontFuncsSetGlyphContourPointFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontFuncsT | `ffuncs`: font functions.
-> FontGetGlyphContourPointFuncT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## fontFuncsSetGlyphExtentsFunc

fontFuncsSetGlyphExtentsFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontFuncsT | `ffuncs`: font functions.
-> FontGetGlyphExtentsFuncT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## fontFuncsSetGlyphFromNameFunc

fontFuncsSetGlyphFromNameFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontFuncsT | `ffuncs`: font functions.
-> FontGetGlyphFromNameFuncT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## fontFuncsSetGlyphFunc

fontFuncsSetGlyphFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontFuncsT | `ffuncs`: font functions.
-> FontGetGlyphFuncT | `func`: callback function.
-> m () |

Deprecated: (Since version 1.2.3)

Deprecated. Use `fontFuncsSetNominalGlyphFunc` and `fontFuncsSetVariationGlyphFunc` instead.

Since: 0.9.2

## fontFuncsSetGlyphHAdvanceFunc

fontFuncsSetGlyphHAdvanceFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontFuncsT | `ffuncs`: font functions.
-> FontGetGlyphAdvanceFuncT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## fontFuncsSetGlyphHAdvancesFunc

fontFuncsSetGlyphHAdvancesFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontFuncsT | `ffuncs`: font functions.
-> FontGetGlyphAdvancesFuncT |
-> m () |

No description available in the introspection data.

Since: 1.8.6

## fontFuncsSetGlyphHKerningFunc

fontFuncsSetGlyphHKerningFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontFuncsT | `ffuncs`: font functions.
-> FontGetGlyphKerningFuncT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## fontFuncsSetGlyphHOriginFunc

fontFuncsSetGlyphHOriginFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontFuncsT | `ffuncs`: font functions.
-> FontGetGlyphOriginFuncT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## fontFuncsSetGlyphNameFunc

fontFuncsSetGlyphNameFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontFuncsT | `ffuncs`: font functions.
-> FontGetGlyphNameFuncT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## fontFuncsSetGlyphVAdvanceFunc

fontFuncsSetGlyphVAdvanceFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontFuncsT | `ffuncs`: font functions.
-> FontGetGlyphAdvanceFuncT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## fontFuncsSetGlyphVAdvancesFunc

fontFuncsSetGlyphVAdvancesFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontFuncsT | `ffuncs`: font functions.
-> FontGetGlyphAdvancesFuncT |
-> m () |

No description available in the introspection data.

Since: 1.8.6

## fontFuncsSetGlyphVKerningFunc

fontFuncsSetGlyphVKerningFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontFuncsT | `ffuncs`: font functions.
-> FontGetGlyphKerningFuncT |
-> m () |

Deprecated: (Since version 2.0.0)

No description available in the introspection data.

Since: 0.9.2

## fontFuncsSetGlyphVOriginFunc

fontFuncsSetGlyphVOriginFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontFuncsT | `ffuncs`: font functions.
-> FontGetGlyphOriginFuncT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## fontFuncsSetNominalGlyphFunc

fontFuncsSetNominalGlyphFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontFuncsT | `ffuncs`: font functions.
-> FontGetNominalGlyphFuncT |
-> m () |

No description available in the introspection data.

Since: 1.2.3

## fontFuncsSetNominalGlyphsFunc

fontFuncsSetNominalGlyphsFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontFuncsT | `ffuncs`: font functions.
-> FontGetNominalGlyphsFuncT |
-> m () |

No description available in the introspection data.

Since: 2.0.0

## fontFuncsSetVariationGlyphFunc

fontFuncsSetVariationGlyphFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontFuncsT | `ffuncs`: font functions.
-> FontGetVariationGlyphFuncT |
-> m () |

No description available in the introspection data.

Since: 1.2.3

## fontGetEmpty

fontGetEmpty :: (HasCallStack, MonadIO m) => m FontT Source #

No description available in the introspection data.

Since: 0.9.2

## fontGetExtentsForDirection

fontGetExtentsForDirection Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> DirectionT |
-> m FontExtentsT |

No description available in the introspection data.

Since: 1.1.3

## fontGetFace

fontGetFace Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> m FaceT |

No description available in the introspection data.

Since: 0.9.2

## fontGetGlyph

fontGetGlyph Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> Word32 |
-> m (Int32, Word32) |

No description available in the introspection data.

Since: 0.9.2

## fontGetGlyphAdvanceForDirection

fontGetGlyphAdvanceForDirection Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> DirectionT |
-> m (Int32, Int32) |

No description available in the introspection data.

Since: 0.9.2

## fontGetGlyphAdvancesForDirection

fontGetGlyphAdvancesForDirection Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> DirectionT |
-> Word32 |
-> Word32 |
-> Word32 |
-> Int32 |
-> Word32 |
-> m () |

No description available in the introspection data.

Since: 1.8.6

## fontGetGlyphContourPoint

fontGetGlyphContourPoint Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> Word32 |
-> m (Int32, Int32, Int32) |

No description available in the introspection data.

Since: 0.9.2

## fontGetGlyphContourPointForOrigin

fontGetGlyphContourPointForOrigin Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> Word32 |
-> DirectionT |
-> m (Int32, Int32, Int32) |

No description available in the introspection data.

Since: 0.9.2

## fontGetGlyphExtents

fontGetGlyphExtents Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> m (Int32, GlyphExtentsT) |

No description available in the introspection data.

Since: 0.9.2

## fontGetGlyphExtentsForOrigin

fontGetGlyphExtentsForOrigin Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> DirectionT |
-> m (Int32, GlyphExtentsT) |

No description available in the introspection data.

Since: 0.9.2

## fontGetGlyphFromName

fontGetGlyphFromName Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> [Text] |
-> m (Int32, Word32) |

No description available in the introspection data.

Since: 0.9.2

## fontGetGlyphHAdvance

fontGetGlyphHAdvance Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> m Int32 |

No description available in the introspection data.

Since: 0.9.2

## fontGetGlyphHAdvances

fontGetGlyphHAdvances Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> Word32 |
-> Word32 |
-> Int32 |
-> Word32 |
-> m () |

No description available in the introspection data.

Since: 1.8.6

## fontGetGlyphHKerning

fontGetGlyphHKerning Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> Word32 |
-> m Int32 |

No description available in the introspection data.

Since: 0.9.2

## fontGetGlyphHOrigin

fontGetGlyphHOrigin Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> m (Int32, Int32, Int32) |

No description available in the introspection data.

Since: 0.9.2

## fontGetGlyphKerningForDirection

fontGetGlyphKerningForDirection Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> Word32 |
-> DirectionT |
-> m (Int32, Int32) |

No description available in the introspection data.

Since: 0.9.2

## fontGetGlyphName

fontGetGlyphName Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> [Text] |
-> m Int32 |

No description available in the introspection data.

Since: 0.9.2

## fontGetGlyphOriginForDirection

fontGetGlyphOriginForDirection Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> DirectionT |
-> m (Int32, Int32) |

No description available in the introspection data.

Since: 0.9.2

## fontGetGlyphVAdvance

fontGetGlyphVAdvance Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> m Int32 |

No description available in the introspection data.

Since: 0.9.2

## fontGetGlyphVAdvances

fontGetGlyphVAdvances Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> Word32 |
-> Word32 |
-> Int32 |
-> Word32 |
-> m () |

No description available in the introspection data.

Since: 1.8.6

## fontGetGlyphVKerning

fontGetGlyphVKerning Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> Word32 |
-> m Int32 |

Deprecated: (Since version 2.0.0)

No description available in the introspection data.

Since: 0.9.2

## fontGetGlyphVOrigin

fontGetGlyphVOrigin Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> m (Int32, Int32, Int32) |

No description available in the introspection data.

Since: 0.9.2

## fontGetHExtents

fontGetHExtents Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> m (Int32, FontExtentsT) |

No description available in the introspection data.

Since: 1.1.3

## fontGetNominalGlyph

fontGetNominalGlyph Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> m (Int32, Word32) |

No description available in the introspection data.

Since: 1.2.3

## fontGetNominalGlyphs

fontGetNominalGlyphs Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> Word32 |
-> Word32 |
-> Word32 |
-> Word32 |
-> m Word32 |

No description available in the introspection data.

Since: 2.6.3

## fontGetParent

fontGetParent Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> m FontT |

No description available in the introspection data.

Since: 0.9.2

## fontGetPpem

fontGetPpem Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> m (Word32, Word32) |

No description available in the introspection data.

Since: 0.9.2

## fontGetPtem

fontGetPtem Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> m Float | Returns: Point size.

Gets the "point size" of the font. A value of 0 means unset.

Since: 0.9.2

## fontGetScale

fontGetScale Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> m (Int32, Int32) |

No description available in the introspection data.

Since: 0.9.2

## fontGetVExtents

fontGetVExtents Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> m (Int32, FontExtentsT) |

No description available in the introspection data.

Since: 1.1.3

## fontGetVarCoordsNormalized

fontGetVarCoordsNormalized :: (HasCallStack, MonadIO m) => FontT -> Word32 -> m Int32 Source #

Return value is valid as long as variation coordinates of the font are not modified.

Since: 1.4.2

## fontGetVariationGlyph

fontGetVariationGlyph Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> Word32 |
-> m (Int32, Word32) |

No description available in the introspection data.

Since: 1.2.3

## fontGlyphFromString

fontGlyphFromString Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> ByteString |
-> m (Int32, Word32) |

No description available in the introspection data.

Since: 0.9.2

## fontGlyphToString

fontGlyphToString Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> [Text] |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## fontIsImmutable

fontIsImmutable Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> m Int32 |

No description available in the introspection data.

Since: 0.9.2

## fontMakeImmutable

fontMakeImmutable Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> m () |

No description available in the introspection data.

Since: 0.9.2

## fontSetFace

fontSetFace Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> FaceT | `face`: new face.
-> m () |

Sets font-face of `font`.

Since: 1.4.3

## fontSetFuncs

fontSetFuncs Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> FontFuncsT |
-> Ptr () |
-> DestroyFuncT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## fontSetFuncsData

fontSetFuncsData Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Ptr () |
-> DestroyFuncT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## fontSetParent

fontSetParent Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> FontT | `parent`: new parent.
-> m () |

Sets parent font of `font`.

Since: 1.0.5

## fontSetPpem

fontSetPpem Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> Word32 |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## fontSetPtem

fontSetPtem Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Float | `ptem`: font size in points.
-> m () |

Sets "point size" of the font. Set to 0 to unset.

There are 72 points in an inch.

Since: 1.6.0

## fontSetScale

fontSetScale Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Int32 |
-> Int32 |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## fontSetVarCoordsDesign

fontSetVarCoordsDesign :: (HasCallStack, MonadIO m) => FontT -> Float -> Word32 -> m () Source #

No description available in the introspection data.

Since: 1.4.2

## fontSetVarCoordsNormalized

fontSetVarCoordsNormalized :: (HasCallStack, MonadIO m) => FontT -> Int32 -> Word32 -> m () Source #

No description available in the introspection data.

Since: 1.4.2

## fontSetVarNamedInstance

fontSetVarNamedInstance Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 | `instanceIndex`: named instance index.
-> m () |

Sets design coords of a font from a named instance index.

Since: 2.6.0

## fontSetVariations

fontSetVariations :: (HasCallStack, MonadIO m) => FontT -> VariationT -> Word32 -> m () Source #

No description available in the introspection data.

Since: 1.4.2

## fontSubtractGlyphOriginForDirection

fontSubtractGlyphOriginForDirection Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font.
-> Word32 |
-> DirectionT |
-> m (Int32, Int32) |

No description available in the introspection data.

Since: 0.9.2

## ftFontChanged

ftFontChanged :: (HasCallStack, MonadIO m) => FontT -> m () Source #

No description available in the introspection data.

## ftFontGetLoadFlags

ftFontGetLoadFlags Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: `FontT` to work upon
-> m Int32 | Returns: FT_Load_Glyph flags found

Fetches the FT_Load_Glyph load flags of the specified `FontT`.

For more information, see https://www.freetype.org/freetype2/docs/reference/ft2-base_interface.html`ft_load_xxx`

Since: 1.0.5

## ftFontSetFuncs

ftFontSetFuncs Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: `FontT` to work upon
-> m () |

Configures the font-functions structure of the specified `FontT` font object to use FreeType font functions.

In particular, you can use this function to configure an existing `FaceT` face object for use with FreeType font functions even if that `FaceT` face object was initially created with `faceCreate`, and therefore was not initially configured to use FreeType font functions.

An `FaceT` face object created with `hb_ft_face_create()` is preconfigured for FreeType font functions and does not require this function to be used.

<note>Note: Internally, this function creates an FT_Face. </note>

Since: 1.0.5

## ftFontSetLoadFlags

ftFontSetLoadFlags Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: `FontT` to work upon
-> Int32 | `loadFlags`: The FreeType load flags to set
-> m () |

Sets the FT_Load_Glyph load flags for the specified `FontT`.

For more information, see https://www.freetype.org/freetype2/docs/reference/ft2-base_interface.html`ft_load_xxx`

Since: 1.0.5

## ftFontUnlockFace

ftFontUnlockFace :: (HasCallStack, MonadIO m) => FontT -> m () Source #

No description available in the introspection data.

Since: 2.6.5

## glibBlobCreate

glibBlobCreate Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Bytes | `gbytes`: the GBytes structure to work upon
-> m BlobT | Returns: the new `BlobT` blob object

Creates an `BlobT` blob from the specified GBytes data structure.

Since: 0.9.38

## glibGetUnicodeFuncs

glibGetUnicodeFuncs Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m UnicodeFuncsT | Returns: a pointer to the `UnicodeFuncsT` Unicode-functions structure

Fetches a Unicode-functions structure that is populated with the appropriate GLib function for each method.

Since: 0.9.38

## glibScriptFromScript

glibScriptFromScript Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> ScriptT | `script`: The `ScriptT` to query
-> m UnicodeScript | Returns: the GUnicodeScript identifier found

Fetches the GUnicodeScript identifier that corresponds to the specified `ScriptT` script.

Since: 0.9.38

## glibScriptToScript

glibScriptToScript Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> UnicodeScript | `script`: The GUnicodeScript identifier to query
-> m ScriptT | Returns: the `ScriptT` script found

Fetches the `ScriptT` script that corresponds to the specified GUnicodeScript identifier.

Since: 0.9.38

## glyphInfoGetGlyphFlags

glyphInfoGetGlyphFlags Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> GlyphInfoT | `info`: a `GlyphInfoT`.
-> m [GlyphFlagsT] | Returns: The `GlyphFlagsT` encoded within `info`.

Returns glyph flags encoded within a `GlyphInfoT`.

Since: 1.5.0

## languageFromString

languageFromString Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> ByteString | `str`: a string representing a BCP 47 language tag
-> m LanguageT | Returns: The `LanguageT` corresponding to the BCP 47 language tag.

Converts `str` representing a BCP 47 language tag to the corresponding `LanguageT`.

Since: 0.9.2

## languageGetDefault

languageGetDefault :: (HasCallStack, MonadIO m) => m LanguageT Source #

Get default language from current locale.

Note that the first time this function is called, it calls "setlocale (LC_CTYPE, nullptr)" to fetch current locale. The underlying setlocale function is, in many implementations, NOT threadsafe. To avoid problems, call this function once before multiple threads can call it. This function is only used from `bufferGuessSegmentProperties` by HarfBuzz itself.

Since: 0.9.2

## languageToString

languageToString Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> LanguageT | `language`: an `LanguageT` to convert.
-> m Text | Returns: A `Nothing`-terminated string representing the `language`. Must not be freed by the caller.

See `languageFromString`.

Since: 0.9.2

## mapAllocationSuccessful

mapAllocationSuccessful Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MapT | `map`: a map.
-> m Int32 |

No description available in the introspection data.

Since: 1.7.7

## mapClear

mapClear Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MapT | `map`: a map.
-> m () |

No description available in the introspection data.

Since: 1.7.7

## mapCreate

mapCreate :: (HasCallStack, MonadIO m) => m MapT Source #

No description available in the introspection data.

Since: 1.7.7

## mapDel

mapDel Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MapT | `map`: a map.
-> Word32 |
-> m () |

No description available in the introspection data.

Since: 1.7.7

## mapGet

mapGet Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MapT | `map`: a map.
-> Word32 |
-> m Word32 |

No description available in the introspection data.

Since: 1.7.7

## mapGetEmpty

mapGetEmpty :: (HasCallStack, MonadIO m) => m MapT Source #

No description available in the introspection data.

Since: 1.7.7

## mapGetPopulation

mapGetPopulation Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MapT | `map`: a map.
-> m Word32 |

No description available in the introspection data.

Since: 1.7.7

## mapHas

mapHas Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MapT | `map`: a map.
-> Word32 |
-> m Int32 |

No description available in the introspection data.

Since: 1.7.7

## mapIsEmpty

mapIsEmpty Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MapT | `map`: a map.
-> m Int32 |

No description available in the introspection data.

Since: 1.7.7

## mapSet

mapSet Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> MapT | `map`: a map.
-> Word32 |
-> Word32 |
-> m () |

No description available in the introspection data.

Since: 1.7.7

## otColorGlyphGetLayers

otColorGlyphGetLayers Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `glyph`: The glyph index to query
-> Word32 | `startOffset`: offset of the first layer to retrieve
-> Maybe [OtColorLayerT] | `layers`: The array of layers found
-> m (Word32, Maybe [OtColorLayerT]) | Returns: Total number of layers available for the glyph index queried

Fetches a list of all color layers for the specified glyph index in the specified face. The list returned will begin at the offset provided.

Since: 2.1.0

## otColorGlyphReferencePng

otColorGlyphReferencePng Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: `FontT` to work upon
-> Word32 | `glyph`: a glyph index
-> m BlobT | Returns: An `BlobT` containing the PNG image for the glyph, if available

Fetches the PNG image for a glyph. This function takes a font object, not a face object, as input. To get an optimally sized PNG blob, the UPEM value must be set on the `font` object. If UPEM is unset, the blob returned will be the largest PNG available.

Since: 2.1.0

## otColorGlyphReferenceSvg

otColorGlyphReferenceSvg Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `glyph`: a svg glyph index
-> m BlobT | Returns: An `BlobT` containing the SVG document of the glyph, if available

Fetches the SVG document for a glyph. The blob may be either plain text or gzip-encoded.

Since: 2.1.0

## otColorHasLayers

otColorHasLayers Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> m Int32 | Returns: true if data found, false otherwise

Tests whether a face includes any `COLR` color layers.

Since: 2.1.0

## otColorHasPalettes

otColorHasPalettes Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> m Int32 | Returns: true if data found, false otherwise

Tests whether a face includes a `CPAL` color-palette table.

Since: 2.1.0

## otColorHasPng

otColorHasPng Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> m Int32 | Returns: true if data found, false otherwise

Tests whether a face has PNG glyph images (either in `CBDT` or `sbix` tables).

Since: 2.1.0

## otColorHasSvg

otColorHasSvg Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon.
-> m Int32 | Returns: true if data found, false otherwise.

Tests whether a face includes any `SVG` glyph images.

Since: 2.1.0

## otColorPaletteColorGetNameId

otColorPaletteColorGetNameId Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `colorIndex`: The index of the color
-> m Word32 | Returns: the Name ID found for the color.

Fetches the `name` table Name ID that provides display names for the specificed color in a face's `CPAL` color palette.

Display names can be generic (e.g., "Background") or specific (e.g., "Eye color").

Since: 2.1.0

## otColorPaletteGetColors

otColorPaletteGetColors Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `paletteIndex`: the index of the color palette to query
-> Word32 | `startOffset`: offset of the first color to retrieve
-> m (Word32, Maybe [Word32]) | Returns: the total number of colors in the palette

Fetches a list of the colors in a color palette.

After calling this function, `colors` will be filled with the palette colors. If `colors` is NULL, the function will just return the number of total colors without storing any actual colors; this can be used for allocating a buffer of suitable size before calling `otColorPaletteGetColors` a second time.

Since: 2.1.0

## otColorPaletteGetCount

otColorPaletteGetCount Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> m Word32 | Returns: the number of palettes found

Fetches the number of color palettes in a face.

Since: 2.1.0

## otColorPaletteGetFlags

otColorPaletteGetFlags Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `paletteIndex`: The index of the color palette
-> m [OtColorPaletteFlagsT] | Returns: the `OtColorPaletteFlagsT` of the requested color palette

Fetches the flags defined for a color palette.

Since: 2.1.0

## otColorPaletteGetNameId

otColorPaletteGetNameId Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `paletteIndex`: The index of the color palette
-> m Word32 | Returns: the Named ID found for the palette. If the requested palette has no name the result is `HB_OT_NAME_ID_INVALID`.

Fetches the `name` table Name ID that provides display names for a `CPAL` color palette.

Palette display names can be generic (e.g., "Default") or provide specific, themed names (e.g., "Spring", "Summer", "Fall", and "Winter").

Since: 2.1.0

## otFontSetFuncs

otFontSetFuncs :: (HasCallStack, MonadIO m) => FontT -> m () Source #

No description available in the introspection data.

Since: 0.9.28

## otLayoutFeatureGetCharacters

otLayoutFeatureGetCharacters Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `tableTag`: table tag to query, "GSUB" or "GPOS".
-> Word32 | `featureIndex`: index of feature to query.
-> Word32 | `startOffset`: offset of the first character to retrieve
-> [Word32] | `characters`: A buffer pointer. The Unicode codepoints of the characters for which this feature provides glyph variants.
-> m (Word32, [Word32]) | Returns: Number of total sample characters in the cvXX feature.

Fetches a list of the characters defined as having a variant under the specified "Character Variant" ("cvXX") feature tag.

<note>Note: If the char_count output value is equal to its input value, then there is a chance there were more characters defined under the feature tag than were returned. This function can be called with incrementally larger start_offset until the char_count output value is lower than its input value, or the size of the characters array can be increased.</note>

Since: 2.0.0

## otLayoutFeatureGetLookups

otLayoutFeatureGetLookups Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `tableTag`: HB_OT_TAG_GSUB or HB_OT_TAG_GPOS
-> Word32 | `featureIndex`: The index of the requested feature
-> Word32 | `startOffset`: offset of the first lookup to retrieve
-> m (Word32, [Word32]) |

Fetches a list of all lookups enumerated for the specified feature, in the specified face's GSUB table or GPOS table. The list returned will begin at the offset provided.

Since: 0.9.7

## otLayoutFeatureGetNameIds

otLayoutFeatureGetNameIds Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `tableTag`: table tag to query, "GSUB" or "GPOS".
-> Word32 | `featureIndex`: index of feature to query.
-> m (Int32, Word32, Word32, Word32, Word32, Word32) | Returns: true if data found, false otherwise

Fetches name indices from feature parameters for "Stylistic Set" ('ssXX') or "Character Variant" ('cvXX') features.

Since: 2.0.0

## otLayoutFeatureWithVariationsGetLookups

otLayoutFeatureWithVariationsGetLookups Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `tableTag`: HB_OT_TAG_GSUB or HB_OT_TAG_GPOS
-> Word32 | `featureIndex`: The index of the feature to query
-> Word32 | `variationsIndex`: The index of the feature variation to query
-> Word32 | `startOffset`: offset of the first lookup to retrieve
-> m (Word32, [Word32]) |

Fetches a list of all lookups enumerated for the specified feature, in the specified face's GSUB table or GPOS table, enabled at the specified variations index. The list returned will begin at the offset provided.

## otLayoutGetAttachPoints

otLayoutGetAttachPoints Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: The `FaceT` to work on
-> Word32 | `glyph`: The `hb_codepoint_t` code point to query
-> Word32 | `startOffset`: offset of the first attachment point to retrieve
-> m (Word32, [Word32]) |

Fetches a list of all attachment points for the specified glyph in the GDEF table of the face. The list returned will begin at the offset provided.

Useful if the client program wishes to cache the list.

## otLayoutGetBaseline

otLayoutGetBaseline Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a font
-> OtLayoutBaselineTagT | `baselineTag`: a baseline tag
-> DirectionT | `direction`: text direction.
-> Word32 | `scriptTag`: script tag.
-> Word32 | `languageTag`: language tag.
-> m (Int32, Int32) | Returns: if found baseline value in the font.

Fetches a baseline value from the face.

Since: 2.6.0

## otLayoutGetGlyphClass

otLayoutGetGlyphClass Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: The `FaceT` to work on
-> Word32 | `glyph`: The `hb_codepoint_t` code point to query
-> m OtLayoutGlyphClassT | Returns: The `OtLayoutGlyphClassT` glyph class of the given code point in the GDEF table of the face.

Fetches the GDEF class of the requested glyph in the specified face.

Since: 0.9.7

## otLayoutGetLigatureCarets

otLayoutGetLigatureCarets Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: The `FontT` to work on
-> DirectionT | `direction`: The `DirectionT` text direction to use
-> Word32 | `glyph`: The `hb_codepoint_t` code point to query
-> Word32 | `startOffset`: offset of the first caret position to retrieve
-> m (Word32, [Int32]) |

Fetches a list of the caret positions defined for a ligature glyph in the GDEF table of the font. The list returned will begin at the offset provided.

## otLayoutGetSizeParams

otLayoutGetSizeParams Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> m (Int32, Word32, Word32, Word32, Word32, Word32) | Returns: true if data found, false otherwise

Fetches optical-size feature data (i.e., the `size` feature from GPOS). Note that the subfamily_id and the subfamily name string (accessible via the subfamily_name_id) as used here are defined as pertaining only to fonts within a font family that differ specifically in their respective size ranges; other ways to differentiate fonts within a subfamily are not covered by the `size` feature.

For more information on this distinction, see the <http://developer.gnome.org/harfbuzz/stable/ https://docs.microsoft.com/en-us/typography/opentype/spec/features_pt#tag-size `size` feature documentation>.

Since: 0.9.10

## otLayoutHasGlyphClasses

otLayoutHasGlyphClasses Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> m Int32 | Returns: true if data found, false otherwise

Tests whether a face has any glyph classes defined in its GDEF table.

## otLayoutHasPositioning

otLayoutHasPositioning Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> m Int32 | Returns: true if the face has GPOS data, false otherwise

No description available in the introspection data.

## otLayoutHasSubstitution

otLayoutHasSubstitution Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> m Int32 | Returns: true if data found, false otherwise

Tests whether the specified face includes any GSUB substitutions.

## otLayoutLanguageFindFeature

otLayoutLanguageFindFeature Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `tableTag`: HB_OT_TAG_GSUB or HB_OT_TAG_GPOS
-> Word32 | `scriptIndex`: The index of the requested script tag
-> Word32 | `languageIndex`: The index of the requested language tag
-> Word32 | `featureTag`: `hb_tag_t` of the feature tag requested
-> m (Int32, Word32) | Returns: true if the feature is found, false otherwise

Fetches the index of a given feature tag in the specified face's GSUB table or GPOS table, underneath the specified script and language.

## otLayoutLanguageGetFeatureIndexes

otLayoutLanguageGetFeatureIndexes Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `tableTag`: HB_OT_TAG_GSUB or HB_OT_TAG_GPOS
-> Word32 | `scriptIndex`: The index of the requested script tag
-> Word32 | `languageIndex`: The index of the requested language tag
-> Word32 | `startOffset`: offset of the first feature tag to retrieve
-> m (Word32, [Word32]) |

Fetches a list of all features in the specified face's GSUB table or GPOS table, underneath the specified script and language. The list returned will begin at the offset provided.

## otLayoutLanguageGetFeatureTags

otLayoutLanguageGetFeatureTags Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `tableTag`: HB_OT_TAG_GSUB or HB_OT_TAG_GPOS
-> Word32 | `scriptIndex`: The index of the requested script tag
-> Word32 | `languageIndex`: The index of the requested language tag
-> Word32 | `startOffset`: offset of the first feature tag to retrieve
-> m (Word32, [Word32]) |

Fetches a list of all features in the specified face's GSUB table or GPOS table, underneath the specified script and language. The list returned will begin at the offset provided.

## otLayoutLanguageGetRequiredFeature

otLayoutLanguageGetRequiredFeature Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `tableTag`: HB_OT_TAG_GSUB or HB_OT_TAG_GPOS
-> Word32 | `scriptIndex`: The index of the requested script tag
-> Word32 | `languageIndex`: The index of the requested language tag
-> m (Int32, Word32, Word32) | Returns: true if the feature is found, false otherwise

Fetches the tag of a requested feature index in the given face's GSUB or GPOS table, underneath the specified script and language.

Since: 0.9.30

## otLayoutLanguageGetRequiredFeatureIndex

otLayoutLanguageGetRequiredFeatureIndex Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `tableTag`: HB_OT_TAG_GSUB or HB_OT_TAG_GPOS
-> Word32 | `scriptIndex`: The index of the requested script tag
-> Word32 | `languageIndex`: The index of the requested language tag
-> m (Int32, Word32) | Returns: true if the feature is found, false otherwise

Fetches the index of a requested feature in the given face's GSUB or GPOS table, underneath the specified script and language.

## otLayoutLookupWouldSubstitute

otLayoutLookupWouldSubstitute Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `lookupIndex`: The index of the lookup to query
-> Word32 | `glyphs`: The sequence of glyphs to query for substitution
-> Word32 | `glyphsLength`: The length of the glyph sequence
-> Int32 | `zeroContext`: `hb_bool_t` indicating whether substitutions should be context-free
-> m Int32 | Returns: true if a substitution would be triggered, false otherwise

Tests whether a specified lookup in the specified face would trigger a substitution on the given glyph sequence.

Since: 0.9.7

## otLayoutScriptFindLanguage

otLayoutScriptFindLanguage Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `tableTag`: HB_OT_TAG_GSUB or HB_OT_TAG_GPOS
-> Word32 | `scriptIndex`: The index of the requested script tag
-> Word32 | `languageTag`: The `hb_tag_t` of the requested language
-> Word32 | `languageIndex`: The index of the requested language
-> m Int32 | Returns: true if the language tag is found, false otherwise

Deprecated: ??

Fetches the index of a given language tag in the specified face's GSUB table or GPOS table, underneath the specified script tag.

## otLayoutScriptGetLanguageTags

otLayoutScriptGetLanguageTags Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `tableTag`: HB_OT_TAG_GSUB or HB_OT_TAG_GPOS
-> Word32 | `scriptIndex`: The index of the requested script tag
-> Word32 | `startOffset`: offset of the first language tag to retrieve
-> m (Word32, [Word32]) |

Fetches a list of language tags in the given face's GSUB or GPOS table, underneath the specified script index. The list returned will begin at the offset provided.

## otLayoutScriptSelectLanguage

otLayoutScriptSelectLanguage Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `tableTag`: HB_OT_TAG_GSUB or HB_OT_TAG_GPOS
-> Word32 | `scriptIndex`: The index of the requested script tag
-> Word32 | `languageCount`: The number of languages in the specified script
-> Word32 | `languageTags`: The array of language tags
-> m (Int32, Word32) | Returns: true if the language tag is found, false otherwise

Fetches the index of a given language tag in the specified face's GSUB table or GPOS table, underneath the specified script index.

Since: 2.0.0

## otLayoutTableChooseScript

otLayoutTableChooseScript Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `tableTag`: HB_OT_TAG_GSUB or HB_OT_TAG_GPOS
-> Word32 | `scriptTags`: Array of `hb_tag_t` script tags
-> m (Int32, Word32, Word32) |

Deprecated since 2.0.0

## otLayoutTableFindFeatureVariations

otLayoutTableFindFeatureVariations Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `tableTag`: HB_OT_TAG_GSUB or HB_OT_TAG_GPOS
-> Int32 | `coords`: The variation coordinates to query
-> Word32 | `numCoords`: The number of variation coorinates
-> m (Int32, Word32) |

Fetches a list of feature variations in the specified face's GSUB table or GPOS table, at the specified variation coordinates.

## otLayoutTableFindScript

otLayoutTableFindScript Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `tableTag`: HB_OT_TAG_GSUB or HB_OT_TAG_GPOS
-> Word32 | `scriptTag`: `hb_tag_t` of the script tag requested
-> m (Int32, Word32) | Returns: true if the script is found, false otherwise

Fetches the index if a given script tag in the specified face's GSUB table or GPOS table.

## otLayoutTableGetFeatureTags

otLayoutTableGetFeatureTags Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `tableTag`: HB_OT_TAG_GSUB or HB_OT_TAG_GPOS
-> Word32 | `startOffset`: offset of the first feature tag to retrieve
-> m (Word32, [Word32]) |

Fetches a list of all feature tags in the given face's GSUB or GPOS table.

## otLayoutTableGetLookupCount

otLayoutTableGetLookupCount Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `tableTag`: HB_OT_TAG_GSUB or HB_OT_TAG_GPOS
-> m Word32 |

Fetches the total number of lookups enumerated in the specified face's GSUB table or GPOS table.

Since: 0.9.22

## otLayoutTableGetScriptTags

otLayoutTableGetScriptTags Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `tableTag`: HB_OT_TAG_GSUB or HB_OT_TAG_GPOS
-> Word32 | `startOffset`: offset of the first script tag to retrieve
-> m (Word32, [Word32]) |

Fetches a list of all scripts enumerated in the specified face's GSUB table or GPOS table. The list returned will begin at the offset provided.

## otLayoutTableSelectScript

otLayoutTableSelectScript Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `tableTag`: HB_OT_TAG_GSUB or HB_OT_TAG_GPOS
-> Word32 | `scriptCount`: Number of script tags in the array
-> Word32 | `scriptTags`: Array of `hb_tag_t` script tags
-> m (Int32, Word32, Word32) |

No description available in the introspection data.

Since: 2.0.0

## otMathGetConstant

otMathGetConstant Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: `FontT` to work upon
-> OtMathConstantT | `constant`: `OtMathConstantT` the constant to retrieve
-> m Int32 | Returns: the requested constant or zero

Fetches the specified math constant. For most constants, the value returned is an `hb_position_t`.

However, if the requested constant is `HB_OT_MATH_CONSTANT_SCRIPT_PERCENT_SCALE_DOWN`, `HB_OT_MATH_CONSTANT_SCRIPT_SCRIPT_PERCENT_SCALE_DOWN` or `HB_OT_MATH_CONSTANT_SCRIPT_PERCENT_SCALE_DOWN`, then the return value is an integer between 0 and 100 representing that percentage.

Since: 1.3.3

## otMathGetGlyphAssembly

otMathGetGlyphAssembly Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: `FontT` to work upon
-> Word32 | `glyph`: The index of the glyph to stretch
-> DirectionT | `direction`: direction of the stretching (horizontal or vertical)
-> Word32 | `startOffset`: offset of the first glyph part to retrieve
-> [OtMathGlyphPartT] | `parts`: the glyph parts returned
-> m (Word32, [OtMathGlyphPartT], Int32) | Returns: the total number of parts in the glyph assembly

Fetches the GlyphAssembly for the specified font, glyph index, and direction. Returned are a list of `OtMathGlyphPartT` glyph parts that can be used to draw the glyph and an italics-correction value (if one is defined in the font).

<note>The `direction` parameter is only used to select between horizontal or vertical directions for the construction. Even though all `DirectionT` values are accepted, only the result of `HB_DIRECTION_IS_HORIZONTAL` is considered.</note>

Since: 1.3.3

## otMathGetGlyphItalicsCorrection

otMathGetGlyphItalicsCorrection Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: `FontT` to work upon
-> Word32 | `glyph`: The glyph index from which to retrieve the value
-> m Int32 | Returns: the italics correction of the glyph or zero

Fetches an italics-correction value (if one exists) for the specified glyph index.

Since: 1.3.3

## otMathGetGlyphKerning

otMathGetGlyphKerning Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: `FontT` to work upon
-> Word32 | `glyph`: The glyph index from which to retrieve the value
-> OtMathKernT | `kern`: The `OtMathKernT` from which to retrieve the value
-> Int32 | `correctionHeight`: the correction height to use to determine the kerning.
-> m Int32 | Returns: requested kerning value or zero

Fetches the math kerning (cut-ins) value for the specified font, glyph index, and `kern`.

If the MathKern table is found, the function examines it to find a height value that is greater or equal to `correctionHeight`. If such a height value is found, corresponding kerning value from the table is returned. If no such height value is found, the last kerning value is returned.

Since: 1.3.3

## otMathGetGlyphTopAccentAttachment

otMathGetGlyphTopAccentAttachment Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: `FontT` to work upon
-> Word32 | `glyph`: The glyph index from which to retrieve the value
-> m Int32 | Returns: the top accent attachment of the glyph or 0.5 * the advance width of `glyph`

Fetches a top-accent-attachment value (if one exists) for the specified glyph index.

For any glyph that does not have a top-accent-attachment value - that is, a glyph not covered by the `MathTopAccentAttachment` table (or, when `font` has no `MathTopAccentAttachment` table or no `MATH` table, any glyph) - the function synthesizes a value, returning the position at one-half the glyph's advance width.

Since: 1.3.3

## otMathGetGlyphVariants

otMathGetGlyphVariants Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: `FontT` to work upon
-> Word32 | `glyph`: The index of the glyph to stretch
-> DirectionT | `direction`: The direction of the stretching (horizontal or vertical)
-> Word32 | `startOffset`: offset of the first variant to retrieve
-> [OtMathGlyphVariantT] | `variants`: array of variants returned
-> m (Word32, [OtMathGlyphVariantT]) | Returns: the total number of size variants available or zero

Fetches the MathGlyphConstruction for the specified font, glyph index, and direction. The corresponding list of size variants is returned as a list of `OtMathGlyphVariantT` structs.

<note>The `direction` parameter is only used to select between horizontal or vertical directions for the construction. Even though all `DirectionT` values are accepted, only the result of `HB_DIRECTION_IS_HORIZONTAL` is considered.</note>

Since: 1.3.3

## otMathGetMinConnectorOverlap

otMathGetMinConnectorOverlap Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: `FontT` to work upon
-> DirectionT | `direction`: direction of the stretching (horizontal or vertical)
-> m Int32 | Returns: requested minimum connector overlap or zero

Fetches the MathVariants table for the specified font and returns the minimum overlap of connecting glyphs that are required to draw a glyph assembly in the specified direction.

<note>The `direction` parameter is only used to select between horizontal or vertical directions for the construction. Even though all `DirectionT` values are accepted, only the result of `HB_DIRECTION_IS_HORIZONTAL` is considered.</note>

Since: 1.3.3

## otMathHasData

otMathHasData Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to test
-> m Int32 | Returns: true if the table is found, false otherwise

Tests whether a face has a `MATH` table.

Since: 1.3.3

## otMathIsGlyphExtendedShape

otMathIsGlyphExtendedShape Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to work upon
-> Word32 | `glyph`: The glyph index to test
-> m Int32 | Returns: true if the glyph is an extended shape, false otherwise

Tests whether the given glyph index is an extended shape in the face.

Since: 1.3.3

## otMetaGetEntryTags

otMetaGetEntryTags :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> OtMetaTagT -> m Word32 Source #

No description available in the introspection data.

## otMetaReferenceEntry

otMetaReferenceEntry Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: a `FaceT` object.
-> OtMetaTagT | `metaTag`: tag of metadata you like to have.
-> m BlobT | Returns: A blob containing the blob.

It fetches metadata entry of a given tag from a font.

Since: 2.6.0

## otMetricsGetPosition

otMetricsGetPosition Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: a `FontT` object.
-> OtMetricsTagT | `metricsTag`: tag of metrics value you like to fetch.
-> m (Int32, Int32) | Returns: Whether found the requested metrics in the font.

It fetches metrics value corresponding to a given tag from a font.

Since: 2.6.0

## otMetricsGetVariation

otMetricsGetVariation :: (HasCallStack, MonadIO m) => FontT -> OtMetricsTagT -> m Float Source #

No description available in the introspection data.

Since: 2.6.0

## otMetricsGetXVariation

otMetricsGetXVariation :: (HasCallStack, MonadIO m) => FontT -> OtMetricsTagT -> m Int32 Source #

No description available in the introspection data.

Since: 2.6.0

## otMetricsGetYVariation

otMetricsGetYVariation :: (HasCallStack, MonadIO m) => FontT -> OtMetricsTagT -> m Int32 Source #

No description available in the introspection data.

Since: 2.6.0

## otNameGetUtf16

otNameGetUtf16 Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: font face.
-> Word32 | `nameId`: OpenType name identifier to fetch.
-> LanguageT | `language`: language to fetch the name for.
-> [Word16] | `text`: buffer to write fetched name into.
-> m (Word32, [Word16]) | Returns: full length of the requested string, or 0 if not found.

Fetches a font name from the OpenType 'name' table. If `language` is `LANGUAGE_INVALID`, English ("en") is assumed. Returns string in UTF-16 encoding.

Since: 2.1.0

## otNameGetUtf32

otNameGetUtf32 Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: font face.
-> Word32 | `nameId`: OpenType name identifier to fetch.
-> LanguageT | `language`: language to fetch the name for.
-> [Word32] | `text`: buffer to write fetched name into.
-> m (Word32, [Word32]) | Returns: full length of the requested string, or 0 if not found.

Fetches a font name from the OpenType 'name' table. If `language` is `LANGUAGE_INVALID`, English ("en") is assumed. Returns string in UTF-32 encoding.

Since: 2.1.0

## otNameGetUtf8

otNameGetUtf8 Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: font face.
-> Word32 | `nameId`: OpenType name identifier to fetch.
-> LanguageT | `language`: language to fetch the name for.
-> [Text] | `text`: buffer to write fetched name into.
-> m (Word32, [Text]) | Returns: full length of the requested string, or 0 if not found.

Fetches a font name from the OpenType 'name' table. If `language` is `LANGUAGE_INVALID`, English ("en") is assumed. Returns string in UTF-8 encoding.

Since: 2.1.0

## otNameListNames

otNameListNames Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: font face.
-> m [OtNameEntryT] | Returns: Array of available name entries.

Enumerates all available name IDs and language combinations. Returned array is owned by the `face` and should not be modified. It can be used as long as `face` is alive.

Since: 2.1.0

## otShapeGlyphsClosure

otShapeGlyphsClosure :: (HasCallStack, MonadIO m) => FontT -> BufferT -> FeatureT -> Word32 -> SetT -> m () Source #

No description available in the introspection data.

Since: 0.9.2

## otTagFromLanguage

otTagFromLanguage :: (HasCallStack, MonadIO m) => LanguageT -> m Word32 Source #

No description available in the introspection data.

## otTagToLanguage

otTagToLanguage :: (HasCallStack, MonadIO m) => Word32 -> m LanguageT Source #

No description available in the introspection data.

Since: 0.9.2

## otTagToScript

otTagToScript :: (HasCallStack, MonadIO m) => Word32 -> m ScriptT Source #

No description available in the introspection data.

## otTagsFromScript

otTagsFromScript :: (HasCallStack, MonadIO m) => ScriptT -> Word32 -> Word32 -> m () Source #

No description available in the introspection data.

## otTagsFromScriptAndLanguage

otTagsFromScriptAndLanguage Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> ScriptT | `script`: an `ScriptT` to convert.
-> LanguageT | `language`: an `LanguageT` to convert.
-> Word32 | `scriptCount`: maximum number of script tags to retrieve (IN) and actual number of script tags retrieved (OUT)
-> Word32 | `languageCount`: maximum number of language tags to retrieve (IN) and actual number of language tags retrieved (OUT)
-> m (Word32, Word32) |

Converts an `ScriptT` and an `LanguageT` to script and language tags.

Since: 2.0.0

## otTagsToScriptAndLanguage

otTagsToScriptAndLanguage Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Word32 | `scriptTag`: a script tag
-> Word32 | `languageTag`: a language tag
-> ScriptT | `script`: the `ScriptT` corresponding to `scriptTag` (OUT).
-> Maybe LanguageT | `language`: the `LanguageT` corresponding to `scriptTag` and `languageTag` (OUT).
-> m () |

Converts a script tag and a language tag to an `ScriptT` and an `LanguageT`.

Since: 2.0.0

## otVarFindAxis

otVarFindAxis :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> OtVarAxisT -> m Int32 Source #

Deprecated: (Since version 2.2.0)

No description available in the introspection data.

Since: 1.4.2

## otVarFindAxisInfo

otVarFindAxisInfo :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> OtVarAxisInfoT -> m Int32 Source #

No description available in the introspection data.

Since: 2.2.0

## otVarGetAxes

otVarGetAxes :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> OtVarAxisT -> m Word32 Source #

Deprecated: (Since version 2.2.0)

No description available in the introspection data.

Since: 1.4.2

## otVarGetAxisCount

otVarGetAxisCount :: (HasCallStack, MonadIO m) => FaceT -> m Word32 Source #

No description available in the introspection data.

Since: 1.4.2

## otVarGetAxisInfos

otVarGetAxisInfos :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> OtVarAxisInfoT -> m Word32 Source #

No description available in the introspection data.

Since: 2.2.0

## otVarGetNamedInstanceCount

otVarGetNamedInstanceCount :: (HasCallStack, MonadIO m) => FaceT -> m Word32 Source #

No description available in the introspection data.

## otVarHasData

otVarHasData Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FaceT | `face`: `FaceT` to test
-> m Int32 | Returns: true if face has a `fvar' table and false otherwise

This function allows to verify the presence of OpenType variation data on the face.

Since: 1.4.2

## otVarNamedInstanceGetDesignCoords

otVarNamedInstanceGetDesignCoords :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Word32 -> Float -> m Word32 Source #

No description available in the introspection data.

## otVarNamedInstanceGetPostscriptNameId

otVarNamedInstanceGetPostscriptNameId :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> m Word32 Source #

No description available in the introspection data.

## otVarNamedInstanceGetSubfamilyNameId

otVarNamedInstanceGetSubfamilyNameId :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> m Word32 Source #

No description available in the introspection data.

## otVarNormalizeCoords

otVarNormalizeCoords :: (HasCallStack, MonadIO m) => FaceT -> Word32 -> Float -> Int32 -> m () Source #

No description available in the introspection data.

Since: 1.4.2

## otVarNormalizeVariations

otVarNormalizeVariations :: (HasCallStack, MonadIO m) => FaceT -> VariationT -> Word32 -> Int32 -> Word32 -> m () Source #

No description available in the introspection data.

Since: 1.4.2

## scriptFromIso15924Tag

scriptFromIso15924Tag Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Word32 | `tag`: an `hb_tag_t` representing an ISO 15924 tag.
-> m ScriptT | Returns: An `ScriptT` corresponding to the ISO 15924 tag.

Converts an ISO 15924 script tag to a corresponding `ScriptT`.

Since: 0.9.2

## scriptFromString

scriptFromString Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> ByteString | `str`: a string representing an ISO 15924 tag.
-> m ScriptT | Returns: An `ScriptT` corresponding to the ISO 15924 tag.

Converts a string `str` representing an ISO 15924 script tag to a corresponding `ScriptT`. Shorthand for `tagFromString` then `scriptFromIso15924Tag`.

Since: 0.9.2

## scriptGetHorizontalDirection

scriptGetHorizontalDirection :: (HasCallStack, MonadIO m) => ScriptT -> m DirectionT Source #

No description available in the introspection data.

Since: 0.9.2

## scriptToIso15924Tag

scriptToIso15924Tag Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> ScriptT | `script`: an `ScriptT` to convert.
-> m Word32 | Returns: An `hb_tag_t` representing an ISO 15924 script tag.

See `scriptFromIso15924Tag`.

Since: 0.9.2

## segmentPropertiesEqual

segmentPropertiesEqual Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SegmentPropertiesT | `a`: first `SegmentPropertiesT` to compare.
-> SegmentPropertiesT | `b`: second `SegmentPropertiesT` to compare.
-> m Int32 | Returns: `true` if all properties of `a` equal those of `b`, false otherwise.

Checks the equality of two `SegmentPropertiesT`'s.

Since: 0.9.7

## segmentPropertiesHash

segmentPropertiesHash Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SegmentPropertiesT | `p`: `SegmentPropertiesT` to hash.
-> m Word32 | Returns: A hash of `p`.

Creates a hash representing `p`.

Since: 0.9.7

## setAdd

setAdd Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> Word32 |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## setAddRange

setAddRange Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> Word32 |
-> Word32 |
-> m () |

No description available in the introspection data.

Since: 0.9.7

## setAllocationSuccessful

setAllocationSuccessful Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> m Int32 |

No description available in the introspection data.

Since: 0.9.2

## setClear

setClear Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> m () |

No description available in the introspection data.

Since: 0.9.2

## setCreate

setCreate :: (HasCallStack, MonadIO m) => m SetT Source #

No description available in the introspection data.

Since: 0.9.2

## setDel

setDel Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> Word32 |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## setDelRange

setDelRange Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> Word32 |
-> Word32 |
-> m () |

No description available in the introspection data.

Since: 0.9.7

## setGetEmpty

setGetEmpty :: (HasCallStack, MonadIO m) => m SetT Source #

No description available in the introspection data.

Since: 0.9.2

## setGetMax

setGetMax Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> m Word32 | Returns: minimum of the set, or `SET_VALUE_INVALID` if set is empty.

Finds the maximum number in the set.

Since: 0.9.7

## setGetMin

setGetMin Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> m Word32 | Returns: minimum of the set, or `SET_VALUE_INVALID` if set is empty.

Finds the minimum number in the set.

Since: 0.9.7

## setGetPopulation

setGetPopulation Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> m Word32 | Returns: set population.

Returns the number of numbers in the set.

Since: 0.9.7

## setHas

setHas Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> Word32 |
-> m Int32 |

No description available in the introspection data.

Since: 0.9.2

## setIntersect

setIntersect Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> SetT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## setInvert

setInvert Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> m () |

Deprecated: (Since version 1.6.1)

No description available in the introspection data.

Since: 0.9.10

## setIsEmpty

setIsEmpty Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> m Int32 |

No description available in the introspection data.

Since: 0.9.7

## setIsEqual

setIsEqual Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> SetT | `other`: other set.
-> m Int32 | Returns: `True` if the two sets are equal, `False` otherwise.

No description available in the introspection data.

Since: 0.9.7

## setIsSubset

setIsSubset Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> SetT | `largerSet`: other set.
-> m Int32 | Returns: `True` if the `set` is a subset of (or equal to) `largerSet`, `False` otherwise.

No description available in the introspection data.

Since: 1.8.1

## setNext

setNext Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> Word32 |
-> m (Int32, Word32) | Returns: whether there was a next value.

Gets the next number in `set` that is greater than current value of `codepoint`.

Set `codepoint` to `SET_VALUE_INVALID` to get started.

Since: 0.9.2

## setNextRange

setNextRange Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> Word32 | `last`: input current last and output last codepoint in the range.
-> m (Int32, Word32, Word32) | Returns: whether there was a next range.

Gets the next consecutive range of numbers in `set` that are greater than current value of `last`.

Set `last` to `SET_VALUE_INVALID` to get started.

Since: 0.9.7

## setPrevious

setPrevious Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> Word32 |
-> m (Int32, Word32) | Returns: whether there was a previous value.

Gets the previous number in `set` that is lower than current value of `codepoint`.

Set `codepoint` to `SET_VALUE_INVALID` to get started.

Since: 1.8.0

## setPreviousRange

setPreviousRange Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> Word32 | `first`: input current first and output first codepoint in the range.
-> m (Int32, Word32, Word32) | Returns: whether there was a previous range.

Gets the previous consecutive range of numbers in `set` that are less than current value of `first`.

Set `first` to `SET_VALUE_INVALID` to get started.

Since: 1.8.0

## setSet

setSet Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> SetT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## setSubtract

setSubtract Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> SetT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## setSymmetricDifference

setSymmetricDifference Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> SetT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## setUnion

setUnion Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> SetT | `set`: a set.
-> SetT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## shape

shape Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: an `FontT` to use for shaping
-> BufferT | `buffer`: an `BufferT` to shape
-> Maybe [FeatureT] | `features`: an array of user specified `FeatureT` or `Nothing`
-> m () |

Shapes `buffer` using `font` turning its Unicode characters content to positioned glyphs. If `features` is not `Nothing`, it will be used to control the features applied during shaping. If two `features` have the same tag but overlapping ranges the value of the feature with the higher index takes precedence.

Since: 0.9.2

## shapeFull

shapeFull Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> FontT | `font`: an `FontT` to use for shaping
-> BufferT | `buffer`: an `BufferT` to shape
-> Maybe [FeatureT] | `features`: an array of user specified `FeatureT` or `Nothing`
-> Maybe [Text] | `shaperList`: a `Nothing`-terminated array of shapers to use or `Nothing`
-> m Int32 | Returns: false if all shapers failed, true otherwise

See `shape` for details. If `shaperList` is not `Nothing`, the specified shapers will be used in the given order, otherwise the default shapers list will be used.

Since: 0.9.2

## shapeListShapers

shapeListShapers Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m [Text] | Returns: an array of constant strings

Retrieves the list of shapers supported by HarfBuzz.

Since: 0.9.2

## shapePlanCreate

shapePlanCreate :: (HasCallStack, MonadIO m) => FaceT -> SegmentPropertiesT -> [FeatureT] -> [Text] -> m ShapePlanT Source #

No description available in the introspection data.

Since: 0.9.7

## shapePlanCreate2

shapePlanCreate2 :: (HasCallStack, MonadIO m) => FaceT -> SegmentPropertiesT -> FeatureT -> Word32 -> Int32 -> Word32 -> Text -> m ShapePlanT Source #

No description available in the introspection data.

## shapePlanCreateCached

shapePlanCreateCached :: (HasCallStack, MonadIO m) => FaceT -> SegmentPropertiesT -> [FeatureT] -> [Text] -> m ShapePlanT Source #

No description available in the introspection data.

Since: 0.9.7

## shapePlanCreateCached2

shapePlanCreateCached2 :: (HasCallStack, MonadIO m) => FaceT -> SegmentPropertiesT -> FeatureT -> Word32 -> Int32 -> Word32 -> Text -> m ShapePlanT Source #

No description available in the introspection data.

## shapePlanExecute

shapePlanExecute Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> ShapePlanT | `shapePlan`: a shape plan.
-> FontT | `font`: a font.
-> BufferT | `buffer`: a buffer.
-> [FeatureT] |
-> m Int32 |

No description available in the introspection data.

Since: 0.9.7

## shapePlanGetEmpty

shapePlanGetEmpty :: (HasCallStack, MonadIO m) => m ShapePlanT Source #

No description available in the introspection data.

Since: 0.9.7

## shapePlanGetShaper

shapePlanGetShaper Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> ShapePlanT | `shapePlan`: a shape plan.
-> m Text |

No description available in the introspection data.

Since: 0.9.7

## tagFromString

tagFromString :: (HasCallStack, MonadIO m) => ByteString -> m Word32 Source #

No description available in the introspection data.

Since: 0.9.2

## unicodeCombiningClass

unicodeCombiningClass :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> Word32 -> m UnicodeCombiningClassT Source #

No description available in the introspection data.

Since: 0.9.2

## unicodeCompose

unicodeCompose Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> UnicodeFuncsT | `ufuncs`: Unicode functions.
-> Word32 |
-> Word32 |
-> m (Int32, Word32) |

No description available in the introspection data.

Since: 0.9.2

## unicodeDecompose

unicodeDecompose Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> UnicodeFuncsT | `ufuncs`: Unicode functions.
-> Word32 |
-> m (Int32, Word32, Word32) |

No description available in the introspection data.

Since: 0.9.2

## unicodeDecomposeCompatibility

unicodeDecomposeCompatibility Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> UnicodeFuncsT | `ufuncs`: Unicode functions.
-> Word32 |
-> m (Word32, Word32) |

Deprecated: (Since version 2.0.0)

No description available in the introspection data.

Since: 0.9.2

## unicodeEastasianWidth

unicodeEastasianWidth :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> Word32 -> m Word32 Source #

Deprecated: (Since version 2.0.0)

No description available in the introspection data.

Since: 0.9.2

## unicodeFuncsCreate

unicodeFuncsCreate :: (HasCallStack, MonadIO m) => Maybe UnicodeFuncsT -> m UnicodeFuncsT Source #

No description available in the introspection data.

Since: 0.9.2

## unicodeFuncsGetDefault

unicodeFuncsGetDefault :: (HasCallStack, MonadIO m) => m UnicodeFuncsT Source #

No description available in the introspection data.

## unicodeFuncsGetEmpty

unicodeFuncsGetEmpty :: (HasCallStack, MonadIO m) => m UnicodeFuncsT Source #

No description available in the introspection data.

Since: 0.9.2

## unicodeFuncsGetParent

unicodeFuncsGetParent Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> UnicodeFuncsT | `ufuncs`: Unicode functions.
-> m UnicodeFuncsT |

No description available in the introspection data.

Since: 0.9.2

## unicodeFuncsIsImmutable

unicodeFuncsIsImmutable Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> UnicodeFuncsT | `ufuncs`: Unicode functions.
-> m Int32 |

No description available in the introspection data.

Since: 0.9.2

## unicodeFuncsMakeImmutable

unicodeFuncsMakeImmutable Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> UnicodeFuncsT | `ufuncs`: Unicode functions.
-> m () |

No description available in the introspection data.

Since: 0.9.2

## unicodeFuncsSetCombiningClassFunc

unicodeFuncsSetCombiningClassFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> UnicodeFuncsT | `ufuncs`: a Unicode function structure
-> UnicodeCombiningClassFuncT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## unicodeFuncsSetComposeFunc

unicodeFuncsSetComposeFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> UnicodeFuncsT | `ufuncs`: a Unicode function structure
-> UnicodeComposeFuncT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## unicodeFuncsSetDecomposeCompatibilityFunc

unicodeFuncsSetDecomposeCompatibilityFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> UnicodeFuncsT | `ufuncs`: a Unicode function structure
-> UnicodeDecomposeCompatibilityFuncT |
-> m () |

Deprecated: (Since version 2.0.0)

No description available in the introspection data.

Since: 0.9.2

## unicodeFuncsSetDecomposeFunc

unicodeFuncsSetDecomposeFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> UnicodeFuncsT | `ufuncs`: a Unicode function structure
-> UnicodeDecomposeFuncT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## unicodeFuncsSetEastasianWidthFunc

unicodeFuncsSetEastasianWidthFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> UnicodeFuncsT | `ufuncs`: a Unicode function structure
-> UnicodeEastasianWidthFuncT |
-> m () |

Deprecated: (Since version 2.0.0)

No description available in the introspection data.

Since: 0.9.2

## unicodeFuncsSetGeneralCategoryFunc

unicodeFuncsSetGeneralCategoryFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> UnicodeFuncsT | `ufuncs`: a Unicode function structure
-> UnicodeGeneralCategoryFuncT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## unicodeFuncsSetMirroringFunc

unicodeFuncsSetMirroringFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> UnicodeFuncsT | `ufuncs`: a Unicode function structure
-> UnicodeMirroringFuncT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## unicodeFuncsSetScriptFunc

unicodeFuncsSetScriptFunc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> UnicodeFuncsT | `ufuncs`: a Unicode function structure
-> UnicodeScriptFuncT |
-> m () |

No description available in the introspection data.

Since: 0.9.2

## unicodeGeneralCategory

unicodeGeneralCategory :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> Word32 -> m UnicodeGeneralCategoryT Source #

No description available in the introspection data.

Since: 0.9.2

## unicodeMirroring

unicodeMirroring :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> Word32 -> m Word32 Source #

No description available in the introspection data.

Since: 0.9.2

## unicodeScript

unicodeScript :: (HasCallStack, MonadIO m) => UnicodeFuncsT -> Word32 -> m ScriptT Source #

No description available in the introspection data.

Since: 0.9.2

## variationFromString

variationFromString :: (HasCallStack, MonadIO m) => Text -> Int32 -> VariationT -> m Int32 Source #

No description available in the introspection data.

Since: 1.4.2

## variationToString

variationToString :: (HasCallStack, MonadIO m) => VariationT -> Text -> Word32 -> m () Source #

No description available in the introspection data.

Since: 1.4.2

## version

version :: (HasCallStack, MonadIO m) => m (Word32, Word32, Word32) Source #

Returns library version as three integer components.

Since: 0.9.2

## versionAtleast

versionAtleast :: (HasCallStack, MonadIO m) => Word32 -> Word32 -> Word32 -> m Int32 Source #

No description available in the introspection data.

Since: 0.9.30

## versionString

versionString Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m Text | Returns: library version string.

Returns library version as a string with three components.

Since: 0.9.2